import Q from "openseadragon";
import "@iiif/helpers";
import { ErrorBoundary as dt } from "react-error-boundary";
import { createStitches as ut } from "@stitches/react";
import h, { useEffect as L, useState as J, useRef as ft } from "react";
import { HAS_PART as X, PART_OF as ie, frameResource as Ce, normalize as ht, serialize as pt, serializeConfigPresentation2 as mt, serializeConfigPresentation3 as vt, isSpecificResource as yt } from "@iiif/parser";
import { v4 as De } from "uuid";
let $ = window.OpenSeadragon;
if (!$ && ($ = Q, !$))
  throw new Error("OpenSeadragon is missing.");
const ve = "http://www.w3.org/2000/svg";
$.Viewer && ($.Viewer.prototype.svgOverlay = function() {
  return this._svgOverlayInfo ? this._svgOverlayInfo : (this._svgOverlayInfo = new Me(this), this._svgOverlayInfo);
});
const Me = function(e) {
  const t = this;
  this._viewer = e, this._containerWidth = 0, this._containerHeight = 0, this._svg = document.createElementNS(ve, "svg"), this._svg.style.position = "absolute", this._svg.style.left = 0, this._svg.style.top = 0, this._svg.style.width = "100%", this._svg.style.height = "100%", this._viewer.canvas.appendChild(this._svg), this._node = document.createElementNS(ve, "g"), this._svg.appendChild(this._node), this._viewer.addHandler("animation", function() {
    t.resize();
  }), this._viewer.addHandler("open", function() {
    t.resize();
  }), this._viewer.addHandler("rotate", function() {
    t.resize();
  }), this._viewer.addHandler("flip", function() {
    t.resize();
  }), this._viewer.addHandler("resize", function() {
    t.resize();
  }), this.resize();
};
Me.prototype = {
  // ----------
  node: function() {
    return this._node;
  },
  // ----------
  resize: function() {
    this._containerWidth !== this._viewer.container.clientWidth && (this._containerWidth = this._viewer.container.clientWidth, this._svg.setAttribute("width", this._containerWidth)), this._containerHeight !== this._viewer.container.clientHeight && (this._containerHeight = this._viewer.container.clientHeight, this._svg.setAttribute("height", this._containerHeight));
    const e = this._viewer.viewport.pixelFromPoint(new $.Point(0, 0), !0), t = this._viewer.viewport.getZoom(!0), r = this._viewer.viewport.getRotation(), n = this._viewer.viewport.getFlip(), i = this._viewer.viewport._containerInnerSize.x;
    let s = i * t;
    const o = s;
    n && (s = -s, e.x = -e.x + i), this._node.setAttribute(
      "transform",
      "translate(" + e.x + "," + e.y + ") scale(" + s + "," + o + ") rotate(" + r + ")"
    );
  },
  // ----------
  onClick: function(e, t) {
    new $.MouseTracker({
      element: e,
      clickHandler: t
    }).setTracking(!0);
  }
};
const gt = (e) => {
  var r, n, i, s, o;
  let t = {
    id: typeof e == "string" ? e : e.source
  };
  if (typeof e == "string") {
    if (e.includes("#xywh=")) {
      const l = e.split("#xywh=");
      if (l && l[1]) {
        const [f, d, c, a] = l[1].split(",").map((y) => Number(y));
        t = {
          id: l[0],
          rect: {
            x: f,
            y: d,
            w: c,
            h: a
          }
        };
      }
    } else if (e.includes("#t=")) {
      const l = e.split("#t=");
      l && l[1] && (t = {
        id: l[0],
        t: l[1]
      });
    }
  } else if (typeof e == "object") {
    if (((r = e.selector) == null ? void 0 : r.type) === "PointSelector")
      t = {
        id: e.source,
        point: {
          x: e.selector.x,
          y: e.selector.y
        }
      };
    else if (((n = e.selector) == null ? void 0 : n.type) === "SvgSelector")
      t = {
        id: e.source,
        svg: e.selector.value
      };
    else if (((i = e.selector) == null ? void 0 : i.type) === "FragmentSelector" && (s = e.selector) != null && s.value.includes("xywh=") && e.source.type == "Canvas" && e.source.id) {
      const l = (o = e.selector) == null ? void 0 : o.value.split("xywh=");
      if (l && l[1]) {
        const [f, d, c, a] = l[1].split(",").map((y) => Number(y));
        t = {
          id: e.source.id,
          rect: {
            x: f,
            y: d,
            w: c,
            h: a
          }
        };
      }
    }
  }
  return t;
}, Et = (e) => fetch(`${e.replace(/\/$/, "")}/info.json`).then((t) => t.json()).then((t) => t).catch((t) => {
  console.error(
    `The IIIF tilesource ${e.replace(
      /\/$/,
      ""
    )}/info.json failed to load: ${t}`
  );
}), wt = (e) => {
  let t, r;
  if (Array.isArray(e) && (t = e[0], t)) {
    let n;
    "@id" in t ? n = t["@id"] : n = t.id, r = n;
  }
  return r;
};
var C = /* @__PURE__ */ ((e) => (e.TiledImage = "tiledImage", e.SimpleImage = "simpleImage", e))(C || {});
const St = (e) => {
  const t = Array.isArray(e == null ? void 0 : e.service) && (e == null ? void 0 : e.service.length) > 0, r = t ? wt(e == null ? void 0 : e.service) : e == null ? void 0 : e.id, n = t ? C.TiledImage : C.SimpleImage;
  return {
    uri: r,
    imageType: n
  };
}, bt = (e, t) => {
  const r = t ? C.TiledImage : C.SimpleImage;
  return {
    uri: e,
    imageType: r
  };
}, Z = 209, xt = {
  colors: {
    /*
     * Black and dark grays in a light theme.
     * Must contrast to 4.5 or greater with `secondary`.
     */
    primary: "#1a1d1e",
    primaryMuted: "#26292b",
    primaryAlt: "#151718",
    /*
     * Key brand color(s).
     * Must contrast to 4.5 or greater with `secondary`.
     */
    accent: `hsl(${Z} 100% 38.2%)`,
    accentMuted: `hsl(${Z} 80% 61.8%)`,
    accentAlt: `hsl(${Z} 80% 30%)`,
    /*
     * White and light grays in a light theme.
     * Must contrast to 4.5 or greater with `primary` and  `accent`.
     */
    secondary: "#FFFFFF",
    secondaryMuted: "#e6e8eb",
    secondaryAlt: "#c1c8cd"
  },
  fontSizes: {
    1: "12px",
    2: "13px",
    3: "15px",
    4: "17px",
    5: "19px",
    6: "21px",
    7: "27px",
    8: "35px",
    9: "59px"
  },
  lineHeights: {
    1: "12px",
    2: "13px",
    3: "15px",
    4: "17px",
    5: "19px",
    6: "21px",
    7: "27px",
    8: "35px",
    9: "59px"
  },
  sizes: {
    1: "5px",
    2: "10px",
    3: "15px",
    4: "20px",
    5: "25px",
    6: "35px",
    7: "45px",
    8: "65px",
    9: "80px"
  },
  space: {
    1: "5px",
    2: "10px",
    3: "15px",
    4: "20px",
    5: "25px",
    6: "35px",
    7: "45px",
    8: "65px",
    9: "80px"
  },
  radii: {
    1: "4px",
    2: "6px",
    3: "8px",
    4: "12px",
    round: "50%",
    pill: "9999px"
  },
  transitions: {
    all: "all 200ms cubic-bezier(0.16, 1, 0.3, 1)"
  },
  zIndices: {
    1: "100",
    2: "200",
    3: "300",
    4: "400",
    max: "999"
  }
}, _t = {
  xxs: "(max-width: 349px)",
  xs: "(max-width: 575px)",
  sm: "(max-width: 767px)",
  md: "(max-width: 991px)",
  lg: "(max-width: 90rem)",
  xl: "(min-width: calc(90rem + 1px))"
}, { styled: F, css: Yr, keyframes: Xr, createTheme: Zr } = ut({
  theme: xt,
  media: _t
}), At = F("div", {
  display: "flex",
  flexDirection: "column",
  alignItems: "center"
}), Rt = F("p", {
  fontWeight: "bold",
  fontSize: "x-large"
}), It = F("span", {
  fontSize: "medium"
}), Tt = ({ error: e }) => {
  const { message: t } = e;
  return /* @__PURE__ */ h.createElement(At, { role: "alert" }, /* @__PURE__ */ h.createElement(Rt, { "data-testid": "headline" }, "Something went wrong"), t && /* @__PURE__ */ h.createElement(It, null, `Error message: ${t}`, " "));
}, ne = F("div", {
  position: "absolute !important",
  zIndex: "1",
  top: "1rem",
  left: "1rem",
  width: "161.8px",
  height: "100px",
  backgroundColor: "#000D",
  boxShadow: "5px 5px 5px #0002",
  borderRadius: "3px",
  ".displayregion": {
    border: " 3px solid $accent !important",
    boxShadow: "0 0 3px #0006"
  },
  "@sm": {
    width: "123px",
    height: "76px"
  },
  "@xs": {
    width: "100px",
    height: "61.8px"
  }
}), Ot = F("div", {
  position: "relative",
  width: "100%",
  height: "100%",
  zIndex: "0",
  ".clover-iiif-image-openseadragon-annotation": {
    position: "relative",
    backgroundColor: "transparent",
    border: "2px solid #0003",
    boxSizing: "content-box",
    borderRadius: "3px",
    boxShadow: "0 0 38vw 38vw transparent",
    transition: "box-shadow 100ms ease-in-out",
    zIndex: "0",
    label: {
      opacity: 0,
      position: "absolute",
      lineHeight: "1.47rem",
      pointerEvents: "none",
      textAlign: "center",
      minWidth: "300px",
      maxWidth: "20vw",
      padding: "0.5rem",
      borderRadius: "3px",
      top: "calc(100% + 0.5rem)",
      left: "50%",
      transform: "translate(-50%, 0)",
      backgroundColor: "$primary",
      color: "$secondary",
      transition: "opacity 100ms ease-in-out"
    },
    "&[data-active=true]": {
      border: "2px solid $accent !important",
      boxShadow: "0 0 38vw 38vw #0003",
      zIndex: "99999999",
      label: {
        opacity: 1
      }
    }
  }
}), Ct = F("div", {
  width: "100%",
  height: "100%",
  maxHeight: "100vh",
  background: "transparent",
  backgroundSize: "contain",
  color: "white",
  position: "relative",
  zIndex: "0",
  overflow: "hidden",
  variants: {
    hasNavigator: {
      true: {
        [`${ne}`]: {
          display: "block"
        }
      },
      false: {
        [`${ne}`]: {
          display: "none"
        }
      }
    }
  }
});
var _ = function(t) {
  return function() {
    const r = { type: t, getType: () => t, toString: () => t };
    return (n, i) => ({
      ...r,
      ...n !== void 0 && { payload: n },
      ...i !== void 0 && { meta: i }
    });
  };
}, Pe = "@iiif/IMPORT_ENTITIES", ke = "@iiif/MODIFY_ENTITY_FIELD", Fe = "@iiif/REORDER_ENTITY_FIELD", Ne = "@iiif/ADD_REFERENCE", se = "@iiif/UPDATE_REFERENCE", Le = "@iiif/REMOVE_REFERENCE", Be = "@iiif/ADD_METADATA", ze = "@iiif/REMOVE_METADATA", oe = "@iiif/UPDATE_METADATA", Ue = "@iiif/REORDER_METADATA", $e = _(Pe)(), Dt = _(ke)(), Mt = _(Fe)(), Pt = _(Ne)(), kt = _(Le)(), Ft = _(se)(), Nt = _(Be)(), Lt = _(oe)(), Bt = _(ze)(), zt = _(Ue)(), Ut = {
  importEntities: $e,
  modifyEntityField: Dt,
  reorderEntityField: Mt,
  addReference: Pt,
  removeReference: kt,
  updateReference: Ft,
  addMetadata: Nt,
  removeMetadata: Bt,
  updateMetadata: Lt,
  reorderMetadata: zt
}, Ve = "@iiif/ADD_MAPPING", He = "@iiif/ADD_MAPPINGS", $t = _(Ve)(), Vt = _(He)(), ae = "RESOURCE_ERROR", qe = "RESOURCE_LOADING", ce = "RESOURCE_READY", We = "@iiif/REQUEST_RESOURCE", je = "@iiif/REQUEST_ERROR", Qe = "@iiif/REQUEST_MISMATCH", Je = "@iiif/REQUEST_COMPLETE", Ht = "@iiif/REQUEST_OFFLINE_RESOURCE", qt = _(We)(), le = _(je)(), Wt = _(Qe)(), jt = _(Je)(), fe = "@iiif/BATCH", Qt = "@iiif/BATCH_IMPORT", de = _(fe)(), Jt = (e, t) => {
  const { entities: r, resource: n, mapping: i } = ht(t);
  if (n.id === void 0)
    return [le({ id: e, message: "ID is not defined in resource." })];
  const s = [$e({ entities: r }), Vt({ mapping: i })];
  return n.id !== e && (s.push($t({ id: e, type: n.type })), s.push(Wt({ requestId: e, actualId: n.id }))), s.push(jt({ id: e })), s;
}, ye = Number.isNaN || function(t) {
  return typeof t == "number" && t !== t;
};
function Yt(e, t) {
  return !!(e === t || ye(e) && ye(t));
}
function ge(e, t) {
  if (!Array.isArray(e) || !Array.isArray(t))
    return e === t;
  if (e.length !== t.length)
    return !1;
  for (let r = 0; r < e.length; r++)
    if (!Yt(e[r], t[r]))
      return !1;
  return !0;
}
function G(e, t, r) {
  const n = e.iiif.requests[t], i = e.iiif.mapping[t];
  if (!i || !e.iiif.entities[i][n.resourceUri])
    return;
  const s = e.iiif.entities[i][n.resourceUri];
  if (s && s[X]) {
    const o = s[X].find((l) => l[ie] === s.id);
    return Ce(s, o);
  }
  return s;
}
function Xt(e) {
  return e && typeof e.then == "function";
}
function Ee(e, t, { waitTimeout: r = 30 } = {}) {
  return (n, i) => {
    const s = e.getStore(), o = s.getState(), l = o.iiif.requests[n];
    if (l) {
      if (l.loadingState === ce) {
        const d = G(o, n);
        if (d)
          return d;
      }
      switch (l.loadingState) {
        case ae:
          break;
        case qe:
          return (async () => {
            let d, c = !1;
            try {
              const a = await Promise.race([
                new Promise((y, g) => {
                  c || (d = s.subscribe(() => {
                    const S = s.getState();
                    if (S.iiif.requests[n].loadingState === ae) {
                      g();
                      return;
                    }
                    if (S.iiif.requests[n].loadingState === ce) {
                      const m = G(S, n);
                      m ? y(m) : g();
                    }
                  }));
                }),
                new Promise(
                  (y, g) => setTimeout(
                    () => {
                      c = !0, g();
                    },
                    r * 60 * 1e3
                  )
                )
              ]);
              if (d && d(), a)
                return a;
            } catch {
              d && d();
            }
          })();
      }
    }
    e.dispatch(qt({ id: n }));
    const f = (d) => {
      if (!d)
        return;
      !d.id && !d["@id"] && (d["@type"] && (d["@id"] = n), d.id = n);
      const c = Jt(n, d);
      return e.dispatch(de({ actions: c })), G(s.getState(), n);
    };
    try {
      const d = t(n, i);
      return Xt(d) ? (async () => {
        try {
          return f(await d);
        } catch (c) {
          throw e.dispatch(le({ id: n, message: c.toString() })), c;
        }
      })() : f(d);
    } catch (d) {
      throw e.dispatch(le({ id: n, message: d.toString() })), d;
    }
  };
}
function Ye() {
  return {
    Collection: {},
    Manifest: {},
    Canvas: {},
    AnnotationPage: {},
    AnnotationCollection: {},
    Annotation: {},
    ContentResource: {},
    Range: {},
    Service: {},
    Selector: {},
    Agent: {}
  };
}
const Zt = { BASE_URL: "/", DEV: !1, MODE: "production", PROD: !0, SSR: !1 };
var we = (e) => {
  let t;
  const r = /* @__PURE__ */ new Set(), n = (c, a) => {
    const y = typeof c == "function" ? c(t) : c;
    if (!Object.is(y, t)) {
      const g = t;
      t = a ?? (typeof y != "object" || y === null) ? y : Object.assign({}, t, y), r.forEach((S) => S(t, g));
    }
  }, i = () => t, f = { setState: n, getState: i, getInitialState: () => d, subscribe: (c) => (r.add(c), () => r.delete(c)), destroy: () => {
    (Zt ? "production" : void 0) !== "production" && console.warn(
      "[DEPRECATED] The `destroy` method will be unsupported in a future version. Instead use unsubscribe function returned by subscribe. Everything will be garbage-collected if store is garbage-collected."
    ), r.clear();
  } }, d = t = e(n, i, f);
  return f;
}, Gt = (e) => e ? we(e) : we, Xe = "@iiif/SET_META_VALUE", Ze = "@iiif/SET_META_VALUE_DYNAMIC", Ge = "@iiif/UNSET_META_VALUE", Kt = _(Xe)(), er = _(Ze)(), tr = _(Ge)(), Se = {
  setMetaValue: Kt,
  setMetaValueDynamic: er,
  unsetMetaValue: tr
};
const K = { BASE_URL: "/", DEV: !1, MODE: "production", PROD: !0, SSR: !1 };
var rr = (e, t) => (r, n, i) => (i.dispatch = (s) => (r((o) => e(o, s), !1, s), s), i.dispatchFromDevtools = !0, { dispatch: (...s) => i.dispatch(...s), ...t }), ir = rr, ue = /* @__PURE__ */ new Map(), Y = (e) => {
  const t = ue.get(e);
  return t ? Object.fromEntries(
    Object.entries(t.stores).map(([r, n]) => [r, n.getState()])
  ) : {};
}, nr = (e, t, r) => {
  if (e === void 0)
    return {
      type: "untracked",
      connection: t.connect(r)
    };
  const n = ue.get(r.name);
  if (n)
    return { type: "tracked", store: e, ...n };
  const i = {
    connection: t.connect(r),
    stores: {}
  };
  return ue.set(r.name, i), { type: "tracked", store: e, ...i };
}, sr = (e, t = {}) => (r, n, i) => {
  const { enabled: s, anonymousActionType: o, store: l, ...f } = t;
  let d;
  try {
    d = (s ?? (K ? "production" : void 0) !== "production") && window.__REDUX_DEVTOOLS_EXTENSION__;
  } catch {
  }
  if (!d)
    return (K ? "production" : void 0) !== "production" && s && console.warn(
      "[zustand devtools middleware] Please install/enable Redux devtools extension"
    ), e(r, n, i);
  const { connection: c, ...a } = nr(l, d, f);
  let y = !0;
  i.setState = (m, I, v) => {
    const E = r(m, I);
    if (!y)
      return E;
    const N = v === void 0 ? { type: o || "anonymous" } : typeof v == "string" ? { type: v } : v;
    return l === void 0 ? (c == null || c.send(N, n()), E) : (c == null || c.send(
      {
        ...N,
        type: `${l}/${N.type}`
      },
      {
        ...Y(f.name),
        [l]: i.getState()
      }
    ), E);
  };
  const g = (...m) => {
    const I = y;
    y = !1, r(...m), y = I;
  }, S = e(i.setState, n, i);
  if (a.type === "untracked" ? c == null || c.init(S) : (a.stores[a.store] = i, c == null || c.init(
    Object.fromEntries(
      Object.entries(a.stores).map(([m, I]) => [
        m,
        m === a.store ? S : I.getState()
      ])
    )
  )), i.dispatchFromDevtools && typeof i.dispatch == "function") {
    let m = !1;
    const I = i.dispatch;
    i.dispatch = (...v) => {
      (K ? "production" : void 0) !== "production" && v[0].type === "__setState" && !m && (console.warn(
        '[zustand devtools middleware] "__setState" action type is reserved to set state from the devtools. Avoid using it.'
      ), m = !0), I(...v);
    };
  }
  return c.subscribe((m) => {
    var I;
    switch (m.type) {
      case "ACTION":
        if (typeof m.payload != "string") {
          console.error(
            "[zustand devtools middleware] Unsupported action format"
          );
          return;
        }
        return ee(
          m.payload,
          (v) => {
            if (v.type === "__setState") {
              if (l === void 0) {
                g(v.state);
                return;
              }
              Object.keys(v.state).length !== 1 && console.error(
                `
                    [zustand devtools middleware] Unsupported __setState action format. 
                    When using 'store' option in devtools(), the 'state' should have only one key, which is a value of 'store' that was passed in devtools(),
                    and value of this only key should be a state object. Example: { "type": "__setState", "state": { "abc123Store": { "foo": "bar" } } }
                    `
              );
              const E = v.state[l];
              if (E == null)
                return;
              JSON.stringify(i.getState()) !== JSON.stringify(E) && g(E);
              return;
            }
            i.dispatchFromDevtools && typeof i.dispatch == "function" && i.dispatch(v);
          }
        );
      case "DISPATCH":
        switch (m.payload.type) {
          case "RESET":
            return g(S), l === void 0 ? c == null ? void 0 : c.init(i.getState()) : c == null ? void 0 : c.init(Y(f.name));
          case "COMMIT":
            if (l === void 0) {
              c == null || c.init(i.getState());
              return;
            }
            return c == null ? void 0 : c.init(Y(f.name));
          case "ROLLBACK":
            return ee(m.state, (v) => {
              if (l === void 0) {
                g(v), c == null || c.init(i.getState());
                return;
              }
              g(v[l]), c == null || c.init(Y(f.name));
            });
          case "JUMP_TO_STATE":
          case "JUMP_TO_ACTION":
            return ee(m.state, (v) => {
              if (l === void 0) {
                g(v);
                return;
              }
              JSON.stringify(i.getState()) !== JSON.stringify(v[l]) && g(v[l]);
            });
          case "IMPORT_STATE": {
            const { nextLiftedState: v } = m.payload, E = (I = v.computedStates.slice(-1)[0]) == null ? void 0 : I.state;
            if (!E)
              return;
            g(l === void 0 ? E : E[l]), c == null || c.send(
              null,
              // FIXME no-any
              v
            );
            return;
          }
          case "PAUSE_RECORDING":
            return y = !y;
        }
        return;
    }
  }), S;
}, or = sr, ee = (e, t) => {
  let r;
  try {
    r = JSON.parse(e);
  } catch (n) {
    console.error(
      "[zustand devtools middleware] Could not parse the received json",
      n
    );
  }
  r !== void 0 && t(r);
}, ar = (e) => (t, r, n) => {
  const i = n.subscribe;
  return n.subscribe = (o, l, f) => {
    let d = o;
    if (l) {
      const c = (f == null ? void 0 : f.equalityFn) || Object.is;
      let a = o(n.getState());
      d = (y) => {
        const g = o(y);
        if (!c(a, g)) {
          const S = a;
          l(a = g, S);
        }
      }, f != null && f.fireImmediately && l(a, a);
    }
    return i(d);
  }, e(t, r, n);
}, cr = ar, lr = (e = {}, t) => {
  switch (t.type) {
    case Ve:
      return {
        ...e,
        [t.payload.id]: t.payload.type
      };
    case He:
      return {
        ...e,
        ...t.payload.mapping
      };
    default:
      return e;
  }
};
function te(e, t, r, n) {
  return !(!e[r] || !e[r][t] || !e[r][t][n] || !Array.isArray(e[r][t][n]));
}
function dr(e, t) {
  const r = {}, n = [];
  for (const [i, s] of Object.entries(e || {})) {
    n.push(i);
    const o = (t || {})[i];
    if (!o || o.length === 0) {
      r[i] = s;
      continue;
    }
    r[i] = o;
  }
  for (const [i, s] of Object.entries(t || {}))
    n.indexOf(i) === -1 && (r[i] = s);
  return r;
}
function u(e) {
  return e.payload;
}
function re(e, t) {
  return typeof e > "u" ? t : e;
}
var ur = (e = Ye(), t) => {
  var n;
  const r = (i, s) => ({
    ...e,
    [u(t).type]: {
      ...e[u(t).type],
      [u(t).id]: {
        ...i,
        ...s
      }
    }
  });
  switch (t.type) {
    case ke: {
      if (!e[u(t).type] || !e[u(t).type][u(t).id])
        return e;
      const i = e[u(t).type][u(t).id];
      return typeof i == "string" ? e : r(i, { [u(t).key]: u(t).value });
    }
    case Fe: {
      if (!te(e, u(t).id, u(t).type, u(t).key))
        return e;
      const i = e[u(t).type][u(t).id];
      if (typeof i == "string")
        return e;
      const s = Array.from(i[u(t).key]), [o] = s.splice(u(t).startIndex, 1);
      return s.splice(u(t).endIndex, 0, o), r(i, { [u(t).key]: s });
    }
    case Pe: {
      const i = Object.keys(u(t).entities), s = { ...e };
      for (const o of i) {
        const l = u(t).entities[o], f = { ...e[o] || {} };
        let d = !1;
        const c = Object.keys(l || {}) || [];
        if (l && c) {
          for (const a of c)
            d = !0, f[a] = e[o][a] ? dr(e[o][a], l[a]) : l[a];
          d && (s[o] = f);
        }
      }
      return s;
    }
    case Ne: {
      if (!te(e, u(t).id, u(t).type, u(t).key))
        return e;
      const i = e[u(t).type][u(t).id], s = Array.from(i[u(t).key]);
      return s.splice(re(u(t).index, s.length + 1), 0, u(t).reference), r(i, { [u(t).key]: s });
    }
    case se:
    case Le: {
      if (!te(e, u(t).id, u(t).type, u(t).key))
        return e;
      const i = e[u(t).type][u(t).id], s = Array.from(i[u(t).key]), o = re(
        u(t).index,
        s.findIndex((l) => l && l.id === u(t).reference.id)
      );
      return o === -1 || ((n = s[o]) == null ? void 0 : n.id) !== u(t).reference.id ? e : (t.type === se ? s.splice(o, 1, u(t).reference) : s.splice(o, 1), r(i, { [u(t).key]: s }));
    }
    case Be: {
      const i = e[u(t).type][u(t).id];
      if (!i)
        return e;
      const s = Array.from(i.metadata || []), o = u(t);
      return s.splice(re(t.payload.beforeIndex, s.length + 1), 0, {
        label: o.label,
        value: o.label
      }), r(i, { metadata: s });
    }
    case Ue: {
      const i = e[u(t).type][u(t).id];
      if (typeof i == "string" || !i)
        return e;
      const s = Array.from(i.metadata || []), [o] = s.splice(u(t).startIndex, 1);
      return s.splice(u(t).endIndex, 0, o), r(i, { metadata: s });
    }
    case oe:
    case ze: {
      const i = e[u(t).type][u(t).id], s = Array.from(i.metadata || []), o = u(t).atIndex;
      return typeof o > "u" || o === -1 || !s[o] ? e : (t.type === oe ? s.splice(o, 1, { label: u(t).label, value: u(t).value }) : s.splice(o, 1), r(i, { metadata: s }));
    }
    default:
      return e;
  }
}, fr = (e = {}, t) => {
  switch (t.type) {
    case We:
    case Ht:
      return {
        ...e,
        [t.payload.id]: {
          requestUri: t.payload.id,
          loadingState: qe,
          uriMismatch: !1,
          resourceUri: t.payload.id
        }
      };
    case Qe:
      return {
        ...e,
        [t.payload.requestId]: {
          ...e[t.payload.requestId] || {},
          uriMismatch: !0,
          resourceUri: t.payload.actualId
        },
        [t.payload.actualId]: {
          requestUri: t.payload.requestId,
          loadingState: e[t.payload.requestId].loadingState,
          uriMismatch: !0,
          resourceUri: t.payload.actualId
        }
      };
    case je:
      return {
        ...e,
        [t.payload.id]: {
          ...e[t.payload.id] || {},
          loadingState: ae,
          error: t.payload.message
        }
      };
    case Je:
      return {
        ...e,
        [t.payload.id]: {
          ...e[t.payload.id] || {},
          loadingState: ce,
          error: void 0
        }
      };
  }
  return e;
}, hr = (e = {}, t) => {
  const { id: r, updateValue: n, value: i, meta: s, key: o } = t && t.payload || {};
  switch (t.type) {
    case Xe:
      return {
        ...e,
        [r]: {
          ...e[r] || {},
          [s]: {
            ...e[r] ? e[r][s] || {} : {},
            [o]: i
          }
        }
      };
    case Ze:
      return {
        ...e,
        [r]: {
          ...e[r] || {},
          [s]: {
            ...e[r] ? e[r][s] || {} : {},
            [o]: e[r] && e[r][s] ? n(e[r][s][o]) : n(void 0)
          }
        }
      };
    case Ge:
      return e[r] && e[r][s] && e[r][s][o] ? {
        ...e,
        [r]: {
          ...e[r] || {},
          [s]: {
            ...e[r] ? e[r][s] || {} : {},
            [o]: void 0
          }
        }
      } : e;
    default:
      return e;
  }
};
function Ke(e = {}) {
  const t = Object.keys(e);
  return function(n = {}, i) {
    let s = !1;
    const o = {};
    for (let l = 0; l < t.length; l++) {
      const f = t[l];
      o[f] = e[f](n[f], i), s = s || o[f] !== n[f];
    }
    return s ? o : n;
  };
}
function pr(e) {
  return (t, r) => r && r.type === fe ? r.payload.actions.reduce(e, t) : r && r.type === Qt ? {
    ...t,
    iiif: {
      ...t.iiif,
      ...r.payload.state
    }
  } : e(t, r);
}
var mr = Ke({
  mapping: lr,
  entities: ur,
  requests: fr,
  meta: hr
});
function vr() {
  return {
    iiif: {
      entities: Ye(),
      meta: {},
      mapping: {},
      requests: {}
    }
  };
}
function yr(e = {}) {
  const {
    enableDevtools: t = !1,
    iiifStoreName: r = "iiif",
    defaultState: n = vr(),
    customReducers: i = {}
  } = e, s = pr(Ke({ [r]: mr, ...i })), l = !!(typeof window < "u" && window.__REDUX_DEVTOOLS_EXTENSION__) ? or : (f, d) => f;
  return Gt(
    //
    cr(
      //
      l(
        //
        ir(s, n),
        { enabled: t }
      )
    )
  );
}
var gr = Object.defineProperty, Er = (e, t, r) => t in e ? gr(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, P = (e, t, r) => (Er(e, typeof t != "symbol" ? t + "" : t, r), r);
function wr(e) {
  return { all: e = e || /* @__PURE__ */ new Map(), on: function(t, r) {
    var n = e.get(t);
    n ? n.push(r) : e.set(t, [r]);
  }, off: function(t, r) {
    var n = e.get(t);
    n && (r ? n.splice(n.indexOf(r) >>> 0, 1) : e.set(t, []));
  }, emit: function(t, r) {
    var n = e.get(t);
    n && n.slice().map(function(i) {
      i(r);
    }), (n = e.get("*")) && n.slice().map(function(i) {
      i(t, r);
    });
  } };
}
function O(e, t, r, n = !0) {
  t[W] = t[W] || [], t[W].push(e);
  const i = /* @__PURE__ */ new Map();
  Object.defineProperty(t, e, {
    enumerable: n,
    get() {
      if (typeof t[z][e] > "u")
        return;
      const s = t[z][e];
      if (!s)
        return s;
      const o = r.get(t[z][e], {
        parent: this.id ? { id: this.id, type: this.type } : void 0
      });
      return i.has(o) || (i.clear(), i.set(o, U(o, r))), i.get(o);
    },
    set(s) {
      t[z][e] !== s && (this[B] ? r.modifyEntityField({ id: this.id, type: this.type }, e, et(s)) : this[z][e] = s);
    }
  });
}
var z = Symbol.for("_refs_"), B = Symbol.for("_reactive_"), W = Symbol.for("_defined_"), be = Symbol.for("_parent_");
function Sr(e, t = !1, r) {
  const n = {
    id: "",
    type: "unknown",
    [W]: [],
    [z]: {},
    [be]: null,
    [B]: null,
    is(i) {
      return typeof i == "string" ? this.id === i : i.id ? i.id === this.id : !1;
    },
    reactive() {
      if (!this[B])
        return this[B] = this.subscribe(() => this.refresh(), !0), () => {
          this.unreactive();
        };
    },
    refresh() {
      if (this.id) {
        const i = this.unwrap();
        for (const s of Object.keys(i || {}))
          this[W].includes(s) ? this[z][s] = i[s] : this[s] = i[s];
      }
    },
    unreactive() {
      this[B] && (this[B](), this[B] = null);
    },
    unwrap() {
      if (!this.id)
        throw new Error("Invalid object");
      const i = this[be];
      return e.get(this.id, { parent: i ? { id: i, type: "unknown" } : void 0 });
    },
    toPresentation3() {
      return e.toPresentation3(this.unwrap());
    },
    toPresentation2() {
      return e.toPresentation2(this.unwrap());
    },
    valueOf() {
      return this.unwrap();
    },
    toJSON() {
      const i = this;
      return {
        ...i,
        items: i.items,
        annotations: i.annotations,
        structures: i.structures,
        seeAlso: i.seeAlso,
        service: i.service,
        services: i.services,
        rendering: i.rendering,
        partOf: i.partOf,
        start: i.start,
        supplementary: i.supplementary,
        homepage: i.homepage,
        thumbnail: i.thumbnail,
        placeholderCanvas: i.placeholderCanvas,
        accompanyingCanvas: i.accompanyingCanvas,
        provider: i.provider
      };
    },
    subscribe(i, s = !0) {
      return e.subscribe(
        () => this.id ? e.get(this.id) : null,
        i,
        s
      );
    }
  };
  return O("items", n, e), O("annotations", n, e), O("structures", n, e), O("seeAlso", n, e), O("rendering", n, e), O("partOf", n, e), O("start", n, e, !1), O("supplementary", n, e), O("homepage", n, e), O("thumbnail", n, e), O("placeholderCanvas", n, e, !1), O("accompanyingCanvas", n, e, !1), O("provider", n, e), O("body", n, e), O("logo", n, e), n;
}
function br(e) {
  return !!e[W];
}
function et(e) {
  return Array.isArray(e) ? e.map((t) => et(t)) : !e || !e.type ? e : { id: e.id, type: e.type };
}
function U(e, t, r = !1, n) {
  if (Array.isArray(e))
    return e.map((l) => U(l, t, r));
  if (!e || !e.type || !e.id)
    return e;
  const i = Sr(t, r), s = Object.create(i), o = Object.assign(s, e);
  return r && o.reactive(), o;
}
function xe(e) {
  switch (e) {
    case "Image":
    case "Video":
    case "Sound":
    case "Dataset":
    case "Text":
    case "Composite":
    case "List":
    case "Independents":
    case "Audience":
      return "ContentResource";
    case "ImageService1":
    case "ImageService2":
    case "ImageService3":
      return "Service";
  }
  return e;
}
var xr = class {
  constructor(e, t) {
    P(this, "options"), P(this, "store"), P(this, "emitter"), P(this, "isBatching", !1), P(this, "batchQueue", []), P(this, "remoteFetcher"), P(this, "staticFetcher"), P(this, "defaultFetcher", (r) => fetch(r).then((n) => n.json())), this.options = Object.assign(
      {
        reducers: {},
        customFetcher: this.defaultFetcher,
        enableDevtools: !0
      },
      e || {}
    ), this.store = t || yr({
      customReducers: this.options.reducers,
      defaultState: this.options.defaultState,
      enableDevtools: this.options.enableDevtools
    }), this.emitter = wr(), this.remoteFetcher = Ee(this, this.options.customFetcher), this.staticFetcher = Ee(this, (r, n) => n);
  }
  batch(e) {
    this.isBatching = !0;
    try {
      e(this), this.isBatching = !1, this.dispatch(de({ actions: this.batchQueue }));
    } catch (t) {
      throw this.batchQueue = [], this.isBatching = !1, t;
    }
    this.batchQueue = [];
  }
  async asyncBatch(e) {
    this.isBatching = !0;
    try {
      await e(this), this.isBatching = !1, this.dispatch(de({ actions: this.batchQueue }));
    } catch (t) {
      throw this.batchQueue = [], this.isBatching = !1, t;
    }
    this.batchQueue = [];
  }
  modifyEntityField(e, t, r) {
    this.dispatch(
      Ut.modifyEntityField({
        id: e.id,
        type: e.type,
        key: t,
        value: r
      })
    );
  }
  dispatch(e) {
    if (this.isBatching)
      this.batchQueue.push(e);
    else {
      if (e.type === fe) {
        for (const n of e.payload.actions)
          this.emitter.emit(n.type, { action: n, state: this.store.getState() });
        this.store.dispatch(e);
        const r = this.getState();
        for (const n of e.payload.actions)
          this.emitter.emit(`after:${n.type}`, { action: n, state: r });
        return;
      }
      this.emitter.emit(e.type, { action: e, state: this.store.getState() }), this.store.dispatch(e);
      const t = this.store.getState();
      this.emitter.emit(`after:${e.type}`, { action: e, state: t });
      return;
    }
  }
  on(e, t) {
    return this.emitter.on(e, t), () => {
      this.emitter.off(e, t);
    };
  }
  serialize(e, t) {
    return pt(this.getState().iiif, e, t);
  }
  toPresentation2(e) {
    return this.serialize(e, mt);
  }
  toPresentation3(e) {
    return this.serialize(e, vt);
  }
  hydrate(e, t, r = {}) {
    return this.get(e, t, { ...r, skipSelfReturn: !1 });
  }
  get(e, t, r = {}) {
    typeof t != "string" && (r = t || {}, t = void 0);
    const { skipSelfReturn: n = !0 } = r || {};
    let i = r.parent ? typeof r.parent == "string" ? r.parent : r.parent.id : void 0;
    if (Array.isArray(e))
      return e.map((c) => this.get(c, r));
    const s = this.getState();
    if (yt(e) && !r.preserveSpecificResources && (e = e.source), typeof e == "string") {
      const c = xe(t || s.iiif.mapping[e]);
      if (!c)
        return n ? null : { id: e, type: "unknown" };
      e = { id: e, type: c };
    }
    if (e && e.partOf && !i && !r.skipPartOfCheck) {
      const c = Array.isArray(e.partOf) ? e.partOf[0] : e.partOf;
      c && (typeof c == "string" && (i = c), typeof c.id == "string" && (i = c.id));
    }
    const o = xe(t || (e == null ? void 0 : e.type)), l = e == null ? void 0 : e.id, f = s.iiif.entities[o];
    if (!f) {
      const c = s.iiif.requests[l];
      return c && c.resourceUri !== l ? this.get(c.resourceUri, r) : n ? null : e;
    }
    const d = f[e.id];
    if (d && d[X]) {
      const c = d[X].find((a) => i ? a[ie] === i : a[ie] === d.id);
      return Ce(d, c);
    }
    return f[e.id] || (n ? null : e);
  }
  select(e) {
    return e(this.getState());
  }
  getStore() {
    return this.store;
  }
  getState() {
    return this.store.getState();
  }
  deep(e, t) {
    if (typeof e > "u")
      return this.get(t, { skipSelfReturn: !1 });
    if (typeof e == "function")
      try {
        const n = e(this.get(t, { skipSelfReturn: !1 })), i = (s) => this.deep(s, n);
        return i.size = Array.isArray(n) ? n.length : 1, i;
      } catch {
        const i = (s) => this.deep(s, void 0);
        return i.size = 0, i;
      }
    const r = (n) => this.deep(n, e);
    return r.size = Array.isArray(e) ? e.length : 1, r;
  }
  loadManifest(e, t) {
    const r = typeof e == "string" ? e : e.id;
    return this.load(r, t);
  }
  loadCollection(e, t) {
    const r = typeof e == "string" ? e : e.id;
    return this.load(r, t);
  }
  load(e, t) {
    const r = typeof e == "string" ? e : e.id;
    return t ? Promise.resolve(this.staticFetcher(r, t)) : Promise.resolve(this.remoteFetcher(r));
  }
  loadSync(e, t) {
    const r = typeof e == "string" ? e : e.id;
    return this.staticFetcher(r, t);
  }
  loadManifestSync(e, t) {
    const r = typeof e == "string" ? e : e.id;
    return this.loadSync(r, t);
  }
  loadCollectionSync(e, t) {
    const r = typeof e == "string" ? e : e.id;
    return this.loadSync(r, t);
  }
  areInputsEqual(e, t) {
    return ge(e, t);
  }
  subscribe(e, t, r) {
    return typeof r > "u" && (typeof t > "u" || t === !1 || t === !0) && (r = t, t = e, e = (n) => n), this.store.subscribe(e, (n) => t(n, this), {
      equalityFn: ge,
      fireImmediately: !r
    });
  }
  async ensureLoaded(e) {
    const t = typeof e == "string" ? e : e.id;
    this.requestStatus(t) || await this.load(t);
  }
  requestStatus(e) {
    return this.select((t) => t.iiif.requests[e]);
  }
  getResourceMeta(e, t) {
    const r = this.getState().iiif.meta[e];
    if (r)
      return t ? r[t] : r;
  }
  getObject(e, t, r = {}) {
    const { reactive: n, ...i } = r;
    return U(this.get(e, t, i), this, n);
  }
  async loadObject(e, t) {
    return U(await this.load(e, t), this);
  }
  async loadManifestObject(e, t) {
    return U(await this.loadManifest(e, t), this);
  }
  async loadCollectionObject(e, t) {
    return U(await this.loadCollection(e, t), this);
  }
  wrapObject(e) {
    return U(this.get(e, { skipSelfReturn: !1 }), this);
  }
  isWrapped(e) {
    return br(e);
  }
  setMetaValue([e, t, r], n) {
    this.dispatch(
      typeof n == "function" ? Se.setMetaValueDynamic({
        id: e,
        meta: t,
        key: r,
        updateValue: n
      }) : Se.setMetaValue({
        id: e,
        meta: t,
        key: r,
        value: n
      })
    );
  }
};
const _r = {
  behavior: "smooth",
  block: "center"
}, k = {
  annotationOverlays: {
    backgroundColor: "#6666ff",
    borderColor: "#000099",
    borderType: "solid",
    borderWidth: "1px",
    opacity: "0.5",
    renderOverlays: !0,
    zoomLevel: 2
  },
  background: "transparent",
  canvasBackgroundColor: "#6662",
  canvasHeight: "500px",
  contentSearch: {
    searchResultsLimit: 20,
    overlays: {
      backgroundColor: "#ff6666",
      borderColor: "#990000",
      borderType: "solid",
      borderWidth: "1px",
      opacity: "0.5",
      renderOverlays: !0,
      zoomLevel: 4
    }
  },
  crossOrigin: void 0,
  ignoreCaptionLabels: [],
  informationPanel: {
    vtt: {
      autoScroll: {
        enabled: !0,
        settings: _r
      }
    },
    open: !0,
    renderAbout: !0,
    renderSupplementing: !0,
    renderToggle: !0,
    renderAnnotation: !0,
    renderContentSearch: !0
  },
  openSeadragon: {},
  requestHeaders: { "Content-Type": "application/json" },
  showDownload: !0,
  showIIIFBadge: !0,
  showTitle: !0,
  withCredentials: !1
};
function Ar(e) {
  let t = {
    ...k.informationPanel.vtt.autoScroll
  };
  return typeof e == "object" && (t = "enabled" in e ? e : { enabled: !0, settings: e }), e === !1 && (t.enabled = !1), Rr(t.settings), t;
}
function Rr({ behavior: e, block: t }) {
  const r = ["auto", "instant", "smooth"], n = ["center", "end", "nearest", "start"];
  if (!r.includes(e))
    throw TypeError(`'${e}' not in ${r.join(" | ")}`);
  if (!n.includes(t))
    throw TypeError(`'${t}' not in ${n.join(" | ")}`);
}
var Ie, Te;
const Ir = Ar(
  (Te = (Ie = k == null ? void 0 : k.informationPanel) == null ? void 0 : Ie.vtt) == null ? void 0 : Te.autoScroll
);
var Oe;
const tt = {
  activeCanvas: "",
  activeManifest: "",
  activeSelector: void 0,
  OSDImageLoaded: !1,
  collection: {},
  configOptions: k,
  customDisplays: [],
  plugins: [],
  isAutoScrollEnabled: Ir.enabled,
  isAutoScrolling: !1,
  isInformationOpen: (Oe = k == null ? void 0 : k.informationPanel) == null ? void 0 : Oe.open,
  isLoaded: !1,
  isUserScrolling: void 0,
  sequence: [[], []],
  vault: new xr(),
  openSeadragonViewer: null,
  viewerId: De(),
  visibleCanvases: [],
  visibleAnnotations: []
}, Tr = h.createContext(tt), Or = h.createContext(tt);
function _e() {
  const e = h.useContext(Tr);
  if (e === void 0)
    throw new Error("useViewerState must be used within a ViewerProvider");
  return e;
}
function rt() {
  const e = h.useContext(Or);
  if (e === void 0)
    throw new Error("useViewerDispatch must be used within a ViewerProvider");
  return e;
}
const Cr = F("button", {
  display: "flex",
  height: "2rem",
  width: "2rem",
  borderRadius: "2rem",
  padding: "0",
  margin: "0",
  fontFamily: "inherit",
  background: "none",
  backgroundColor: "$primary",
  border: "none",
  color: "white",
  cursor: "pointer",
  marginLeft: "0.618rem",
  filter: "drop-shadow(2px 2px 5px #0003)",
  transition: "$all",
  boxSizing: "content-box !important",
  "&:first-child": {
    marginLeft: "0"
  },
  "@xs": {
    marginBottom: "0.618rem",
    marginLeft: "0",
    "&:last-child": {
      marginBottom: "0"
    }
  },
  svg: {
    height: "60%",
    width: "60%",
    padding: "20%",
    fill: "$secondary",
    stroke: "$secondary",
    filter: "drop-shadow(2px 2px 5px #0003)",
    transition: "$all",
    boxSizing: "inherit"
  },
  "&:hover, &:focus": {
    backgroundColor: "$accent"
  },
  "&[data-button=rotate-right]": {
    "&:hover, &:focus": {
      svg: {
        rotate: "45deg"
      }
    }
  },
  "&[data-button=rotate-left]": {
    transform: "scaleX(-1)",
    "&:hover, &:focus": {
      svg: {
        rotate: "45deg"
      }
    }
  },
  "&[data-button=reset]": {
    "&:hover, &:focus": {
      svg: {
        rotate: "-15deg"
      }
    }
  }
}), q = ({ className: e, id: t, label: r, children: n }) => {
  const i = r.toLowerCase().replace(/\s/g, "-");
  return /* @__PURE__ */ h.createElement(
    Cr,
    {
      id: t,
      className: e,
      "data-testid": "openseadragon-button",
      "data-button": i
    },
    /* @__PURE__ */ h.createElement(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        "aria-labelledby": `${t}-svg-title`,
        "data-testid": "openseadragon-button-svg",
        focusable: "false",
        viewBox: "0 0 512 512",
        role: "img"
      },
      /* @__PURE__ */ h.createElement("title", { id: `${t}-svg-title` }, r),
      n
    )
  );
}, Dr = F("div", {
  position: "absolute",
  zIndex: "1",
  top: "1rem",
  right: "1rem",
  display: "flex",
  "@xs": {
    flexDirection: "column",
    zIndex: "2"
  },
  variants: {
    hasPlaceholder: {
      true: {
        right: "3.618rem",
        "@xs": {
          top: "3.618rem",
          right: "1rem"
        }
      },
      false: {
        right: "1rem",
        "@xs": {
          top: "1rem",
          right: "1rem"
        }
      }
    }
  }
}), Mr = () => /* @__PURE__ */ h.createElement(
  "path",
  {
    strokeLinecap: "round",
    strokeMiterlimit: "10",
    strokeWidth: "45",
    d: "M256 112v288M400 256H112"
  }
), Pr = () => /* @__PURE__ */ h.createElement(
  "path",
  {
    strokeLinecap: "round",
    strokeMiterlimit: "10",
    strokeWidth: "45",
    d: "M400 256H112"
  }
), kr = () => /* @__PURE__ */ h.createElement(
  "path",
  {
    fill: "none",
    stroke: "currentColor",
    strokeLinecap: "round",
    strokeLinejoin: "round",
    strokeWidth: "32",
    d: "M432 320v112H320M421.8 421.77L304 304M80 192V80h112M90.2 90.23L208 208M320 80h112v112M421.77 90.2L304 208M192 432H80V320M90.23 421.8L208 304"
  }
), Fr = () => /* @__PURE__ */ h.createElement("path", { d: "M448 440a16 16 0 01-12.61-6.15c-22.86-29.27-44.07-51.86-73.32-67C335 352.88 301 345.59 256 344.23V424a16 16 0 01-27 11.57l-176-168a16 16 0 010-23.14l176-168A16 16 0 01256 88v80.36c74.14 3.41 129.38 30.91 164.35 81.87C449.32 292.44 464 350.9 464 424a16 16 0 01-16 16z" }), Ae = () => /* @__PURE__ */ h.createElement(h.Fragment, null, /* @__PURE__ */ h.createElement(
  "path",
  {
    fill: "none",
    strokeLinecap: "round",
    strokeMiterlimit: "10",
    strokeWidth: "45",
    d: "M400 148l-21.12-24.57A191.43 191.43 0 00240 64C134 64 48 150 48 256s86 192 192 192a192.09 192.09 0 00181.07-128"
  }
), /* @__PURE__ */ h.createElement("path", { d: "M464 97.42V208a16 16 0 01-16 16H337.42c-14.26 0-21.4-17.23-11.32-27.31L436.69 86.1C446.77 76 464 83.16 464 97.42z" })), Nr = ({
  _cloverViewerHasPlaceholder: e,
  config: t
}) => {
  const r = _e(), { activeCanvas: n, plugins: i, vault: s, openSeadragonViewer: o } = r, l = s.get({
    id: n,
    type: "Canvas"
  });
  function f() {
    return i.filter((d) => {
      var c;
      return (c = d.imageViewer) == null ? void 0 : c.controls;
    }).map((d, c) => {
      var y, g, S, m;
      const a = (g = (y = d.imageViewer) == null ? void 0 : y.controls) == null ? void 0 : g.component;
      return /* @__PURE__ */ h.createElement(
        a,
        {
          key: c,
          ...(m = (S = d == null ? void 0 : d.imageViewer) == null ? void 0 : S.controls) == null ? void 0 : m.componentProps,
          canvas: l,
          useViewerDispatch: rt,
          useViewerState: _e
        }
      );
    });
  }
  return L(() => {
    if (!o) return;
    const d = o.viewport.getRotation();
    o.addHandler("home", () => {
      o.viewport.setRotation(d);
    });
  }, [o]), /* @__PURE__ */ h.createElement(
    Dr,
    {
      "data-testid": "clover-iiif-image-openseadragon-controls",
      hasPlaceholder: e
    },
    t.showZoomControl && /* @__PURE__ */ h.createElement(h.Fragment, null, /* @__PURE__ */ h.createElement(q, { id: t.zoomInButton, label: "zoom in" }, /* @__PURE__ */ h.createElement(Mr, null)), /* @__PURE__ */ h.createElement(q, { id: t.zoomOutButton, label: "zoom out" }, /* @__PURE__ */ h.createElement(Pr, null))),
    t.showFullPageControl && /* @__PURE__ */ h.createElement(q, { id: t.fullPageButton, label: "full page" }, /* @__PURE__ */ h.createElement(kr, null)),
    t.showRotationControl && /* @__PURE__ */ h.createElement(h.Fragment, null, /* @__PURE__ */ h.createElement(q, { id: t.rotateRightButton, label: "rotate right" }, /* @__PURE__ */ h.createElement(Ae, null)), /* @__PURE__ */ h.createElement(q, { id: t.rotateLeftButton, label: "rotate left" }, /* @__PURE__ */ h.createElement(Ae, null))),
    t.showHomeControl && /* @__PURE__ */ h.createElement(q, { id: t.homeButton, label: "reset" }, /* @__PURE__ */ h.createElement(Fr, null)),
    f()
  );
};
async function it(e, t = 3, r = 500) {
  try {
    return await e();
  } catch (n) {
    if (t <= 0) throw n;
    return await new Promise((i) => setTimeout(i, r)), it(e, t - 1, r);
  }
}
const Lr = (e) => new Promise((t) => setTimeout(t, e)), Re = async (e, t, r = 3, n = 300) => {
  for (let i = 0; i < r; i++) {
    const s = t ? t - 1 : 0, o = e.getItemAt(s);
    if (o) return o;
    await Lr(n);
  }
  throw new Error("No base item found at index 0 after retries");
}, Br = ({
  annotations: e,
  ariaLabel: t,
  config: r,
  uri: n,
  _cloverViewerHasPlaceholder: i,
  imageType: s,
  openSeadragonCallback: o
}) => {
  const [l, f] = J([]), [d, c] = J([]), [a, y] = J(), [g, S] = J([]), m = rt(), I = ft(!1), v = "clover-iiif-image-openseadragon-annotation";
  L(() => (I.current || (I.current = !0, a || y(Q(r))), () => a == null ? void 0 : a.destroy()), []), L(() => {
    E();
  }, [a, o]), L(() => {
    a && JSON.stringify(n) !== JSON.stringify(d) && (a.forceRedraw(), c(n));
  }, [a, d, n]), L(() => {
    if (!d.length || !a) return;
    a.close(), (async () => {
      switch (s) {
        case "simpleImage":
          let D = 1, b = 0;
          for (let x = 0; x < d.length; x++) {
            const A = d[x];
            if (e) {
              const p = new Image();
              p.src = A, await p.decode(), S((R) => [
                ...R,
                {
                  width: p == null ? void 0 : p.width,
                  height: p == null ? void 0 : p.height
                }
              ]);
            }
            try {
              if (x !== 0) {
                const R = (await Re(
                  a.world,
                  x
                )).getBounds();
                b = R.x + R.width, D = R.height;
              }
              a.addSimpleImage({
                url: A,
                x: b,
                y: 0,
                height: D,
                success: () => {
                  f((p) => [...p, A]), typeof m == "function" && m({
                    type: "updateOSDImageLoaded",
                    OSDImageLoaded: !0
                  });
                }
              });
            } catch (p) {
              console.error(`Failed to load image at ${A}:`, p);
            }
          }
          break;
        case "tiledImage": {
          let x = 1, A = 0;
          for (let p = 0; p < d.length; p++) {
            const R = d[p];
            try {
              const M = await it(
                () => Et(R),
                3,
                1e3
              );
              if (!M) throw new Error(`No tile source for ${R}`);
              if (p !== 0) {
                const H = (await Re(
                  a.world,
                  p
                )).getBounds();
                A = H.x + H.width, x = H.height;
              }
              a.addTiledImage({
                tileSource: M,
                x: A,
                y: 0,
                height: x,
                success: () => {
                  f((V) => [...V, R]), typeof m == "function" && m({
                    type: "updateOSDImageLoaded",
                    OSDImageLoaded: !0
                  });
                }
              });
            } catch (M) {
              console.error(`Failed to load tile at ${R}:`, M);
            }
          }
          break;
        }
        default:
          console.warn(`Unsupported imageType: "${s}"`);
          break;
      }
    })().catch((D) => console.error("Error drawing tiles", D));
  }, [d, s, a]), L(() => {
    if (l) {
      let D = 0;
      const b = () => {
        if (D < 3) {
          const x = a == null ? void 0 : a.world.getHomeBounds();
          x && (a == null || a.viewport.fitBounds(x, !0)), D++, setTimeout(b, 50);
        }
      };
      b(), a == null || a.addHandler("canvas-click", (x) => {
        const A = a == null ? void 0 : a.getOverlayById(
          x.originalTarget.id
        );
        if (A) {
          const p = A == null ? void 0 : A.getBounds(a.viewport);
          return p.x -= 0.1, p.y -= 0.1, p.width += 0.2, p.height += 0.2, a == null || a.viewport.fitBounds(p, !1), x.preventDefaultAction = !0;
        }
      });
    }
  }, [l]), L(() => {
    function N(D, b, x) {
      let A = D * x;
      if (b === 0) return A;
      for (; b > 0; ) {
        const p = a == null ? void 0 : a.world.getItemAt(b - 1);
        if (p) {
          const R = p.getBounds().width;
          A += R, b--;
        } else
          break;
      }
      return A;
    }
    e && (a == null || a.clearOverlays(), e.forEach((D) => {
      var H, he, pe, me;
      const { annotation: b, targetIndex: x } = D, A = ((he = (H = a == null ? void 0 : a.viewport) == null ? void 0 : H.getBounds()) == null ? void 0 : he.width) || 1, p = a == null ? void 0 : a.world.getItemAt(x), R = p ? (p == null ? void 0 : p.getBounds().width) / (p == null ? void 0 : p.getContentSize().x) : ((pe = g[x]) == null ? void 0 : pe.width) / A, M = gt(
        b == null ? void 0 : b.target
      ), V = b != null && b.body ? (me = b == null ? void 0 : b.body[0]) == null ? void 0 : me.value : void 0;
      if (M != null && M.rect) {
        const { x: nt, y: st, w: ot, h: at } = M == null ? void 0 : M.rect, ct = N(nt, x, R), j = new Q.Rect(
          ct,
          st * R,
          ot * R,
          at * R
        ), w = document.createElement("button");
        if (w.classList.add(v), w.id = b.id, w.setAttribute("tabindex", "0"), w.setAttribute("role", "button"), w.setAttribute("data-active", "true"), w.setAttribute("tabindex", "0"), w.setAttribute("role", "button"), w.setAttribute("data-active", "false"), V) {
          w.setAttribute("aria-label", V);
          const T = document.createElement("label");
          T.innerHTML = V, w.appendChild(T);
        }
        w.addEventListener("mousedown", (T) => {
          T.stopPropagation(), T.preventDefault();
        }), w.addEventListener("touchstart", (T) => {
          T.stopPropagation(), T.preventDefault();
        }), w.addEventListener("click", (T) => {
          T.stopPropagation(), T.preventDefault();
        }), w.addEventListener("keydown", (T) => {
          if (T.key === "Enter") {
            T.stopPropagation(), T.preventDefault();
            const lt = new Q.Rect(
              j.x - 0.1,
              j.y - 0.1,
              j.width + 0.2,
              j.height + 0.2
            );
            a == null || a.viewport.fitBounds(lt, !1);
          }
        }), w.addEventListener("focus", () => {
          w.setAttribute("data-active", "true");
        }), w.addEventListener("mouseover", () => {
          w.setAttribute("data-active", "true");
        }), w.addEventListener("mouseout", () => {
          w.removeAttribute("data-active");
        }), w.addEventListener("blur", () => {
          w.removeAttribute("data-active");
        }), a == null || a.addOverlay(w, j, Q.Placement.CENTER);
      }
    }), E());
  }, [l, e]);
  function E() {
    a && (o == null || o(a));
  }
  return /* @__PURE__ */ h.createElement(
    Ct,
    {
      className: "clover-iiif-image-openseadragon",
      "data-testid": "clover-iiif-image-openseadragon",
      "data-openseadragon-instance": r.id,
      hasNavigator: r.showNavigator
    },
    /* @__PURE__ */ h.createElement(
      Nr,
      {
        _cloverViewerHasPlaceholder: i,
        config: r
      }
    ),
    r.showNavigator && /* @__PURE__ */ h.createElement(
      ne,
      {
        id: r.navigatorId,
        "data-testid": "clover-iiif-image-openseadragon-navigator"
      }
    ),
    /* @__PURE__ */ h.createElement(
      Ot,
      {
        id: r.id,
        "data-testid": "clover-iiif-image-openseadragon-viewport",
        role: "img",
        ...t && { "aria-label": t }
      }
    )
  );
};
function zr(e) {
  return {
    id: `openseadragon-${e}`,
    navigatorId: `openseadragon-navigator-${e}`,
    loadTilesWithAjax: !0,
    fullPageButton: `fullPage-${e}`,
    homeButton: `reset-${e}`,
    rotateLeftButton: `rotateLeft-${e}`,
    rotateRightButton: `rotateRight-${e}`,
    zoomInButton: `zoomIn-${e}`,
    zoomOutButton: `zoomOut-${e}`,
    showNavigator: !0,
    showFullPageControl: !0,
    showHomeControl: !0,
    showRotationControl: !0,
    showZoomControl: !0,
    navigatorBorderColor: "transparent",
    gestureSettingsMouse: {
      clickToZoom: !0,
      dblClickToZoom: !0,
      pinchToZoom: !0,
      scrollToZoom: !1
    }
  };
}
const Ur = (e, t = "none") => {
  if (!e) return null;
  if (typeof e == "string") return [e];
  if (!e[t]) {
    const r = Object.getOwnPropertyNames(e);
    if (r.length > 0) return e[r[0]];
  }
  return !e[t] || !Array.isArray(e[t]) ? null : e[t];
}, $r = (e, t = "none", r = ", ") => {
  const n = Ur(e, t);
  return Array.isArray(n) ? n.join(`${r}`) : n;
}, Gr = ({
  _cloverViewerHasPlaceholder: e = !1,
  annotations: t,
  body: r,
  instanceId: n,
  isTiledImage: i = !1,
  label: s,
  src: o = "",
  openSeadragonCallback: l,
  openSeadragonConfig: f = {}
}) => {
  const d = n ?? De(), c = typeof s == "string" ? s : $r(s), a = {
    ...zr(d),
    ...f
  }, y = Array.isArray(r) ? r : r ? [r] : [], g = Array.isArray(o) ? o : o ? [o] : [];
  let S = [], m = C.SimpleImage;
  if (y.length) {
    const v = y.map(St);
    S = v.map((E) => E.uri).filter(Boolean), m = v.some(
      (E) => E.imageType === C.TiledImage
    ) ? C.TiledImage : C.SimpleImage;
  } else if (g.length) {
    const v = g.map((E) => bt(E, i));
    S = v.map((E) => E.uri).filter(Boolean), m = v.some(
      (E) => E.imageType === C.TiledImage
    ) ? C.TiledImage : C.SimpleImage;
  }
  if (!S.length) return null;
  const I = (v) => {
    l == null || l(v);
  };
  return /* @__PURE__ */ h.createElement(dt, { FallbackComponent: Tt }, /* @__PURE__ */ h.createElement(
    Br,
    {
      _cloverViewerHasPlaceholder: e,
      annotations: t,
      ariaLabel: c,
      config: a,
      imageType: m,
      key: d,
      uri: S,
      openSeadragonCallback: I
    }
  ));
};
export {
  Gr as default
};
//# sourceMappingURL=index.mjs.map
