import Ze from "i18next-browser-languagedetector";
import Qe from "i18next";
import { initReactI18next as Xe, useTranslation as ge } from "react-i18next";
import a, { useRef as w, useEffect as j, useCallback as Ye, createContext as ne, useContext as et, useState as $, useLayoutEffect as tt, forwardRef as ye } from "react";
import { ErrorBoundary as rt } from "react-error-boundary";
import { createStitches as nt } from "@stitches/react";
import it from "sanitize-html";
import H from "hls.js";
import Z, { Navigation as ot, A11y as at } from "swiper";
import * as be from "@radix-ui/react-aspect-ratio";
const st = "Close", lt = "Next", ct = "Previous", ut = "Search", pt = "Search...", ft = "Share", dt = "View All", ht = "Failed", mt = "Copied", vt = "Loading...", gt = "Search", yt = "No Results", bt = "More Results", xt = "Select", wt = "Viewer", St = "About", Ct = "Annotations", Et = "Search", At = "More Information", $t = "View Collection", Rt = "Copy Collection URL", It = "View Manifest", Lt = "Copy Manifest URL", Ot = {
  commonClose: st,
  commonNext: lt,
  commonPrevious: ct,
  commonSearch: ut,
  commonSearchPlaceholder: pt,
  commonShare: ft,
  commonViewAll: dt,
  copyFailure: ht,
  copySuccess: mt,
  contentSearchLoading: vt,
  contentSearchPlaceholder: gt,
  contentSearchResultsNone: yt,
  contentSearchResultsMore: bt,
  informationPanelTabs: xt,
  informationPanelTabsClose: wt,
  informationPanelTabsAbout: St,
  informationPanelTabsAnnotations: Ct,
  informationPanelTabsSearch: Et,
  informationPanelToggle: At,
  shareCollectionJson: $t,
  shareCollectionCopy: Rt,
  shareManifestJson: It,
  shareManifestCopy: Lt
}, Tt = {}, jt = {
  en: Ot,
  pt: Tt
}, Q = "clover", Pt = Object.fromEntries(
  Object.entries(jt).map(([e, t]) => [
    e,
    { [`${Q}`]: t }
  ])
);
Qe.use(Ze).use(Xe).init({
  defaultNS: Q,
  fallbackLng: "en",
  ns: [Q],
  resources: { ...Pt }
});
const G = {
  isLoaded: !1,
  options: {
    credentials: "omit"
  }
}, xe = a.createContext(G), Mt = a.createContext(G);
function _t(e, t) {
  switch (t.type) {
    case "updateIsLoaded":
      return {
        ...e,
        isLoaded: t.isLoaded
      };
    default:
      throw new Error(`Unhandled action type: ${t.type}`);
  }
}
const Nt = ({
  initialState: e = G,
  children: t
}) => {
  const [r, n] = a.useReducer(_t, e);
  return /* @__PURE__ */ a.createElement(xe.Provider, { value: r }, /* @__PURE__ */ a.createElement(
    Mt.Provider,
    {
      value: n
    },
    t
  ));
};
function Dt() {
  const e = a.useContext(xe);
  if (e === void 0)
    throw new Error(
      "useCollectionState must be used within a CollectionProvider"
    );
  return e;
}
const K = 209, zt = {
  colors: {
    /*
     * Black and dark grays in a light theme.
     * Must contrast to 4.5 or greater with `secondary`.
     */
    primary: "#1a1d1e",
    primaryMuted: "#26292b",
    primaryAlt: "#151718",
    /*
     * Key brand color(s).
     * Must contrast to 4.5 or greater with `secondary`.
     */
    accent: `hsl(${K} 100% 38.2%)`,
    accentMuted: `hsl(${K} 80% 61.8%)`,
    accentAlt: `hsl(${K} 80% 30%)`,
    /*
     * White and light grays in a light theme.
     * Must contrast to 4.5 or greater with `primary` and  `accent`.
     */
    secondary: "#FFFFFF",
    secondaryMuted: "#e6e8eb",
    secondaryAlt: "#c1c8cd"
  },
  fontSizes: {
    1: "12px",
    2: "13px",
    3: "15px",
    4: "17px",
    5: "19px",
    6: "21px",
    7: "27px",
    8: "35px",
    9: "59px"
  },
  lineHeights: {
    1: "12px",
    2: "13px",
    3: "15px",
    4: "17px",
    5: "19px",
    6: "21px",
    7: "27px",
    8: "35px",
    9: "59px"
  },
  sizes: {
    1: "5px",
    2: "10px",
    3: "15px",
    4: "20px",
    5: "25px",
    6: "35px",
    7: "45px",
    8: "65px",
    9: "80px"
  },
  space: {
    1: "5px",
    2: "10px",
    3: "15px",
    4: "20px",
    5: "25px",
    6: "35px",
    7: "45px",
    8: "65px",
    9: "80px"
  },
  radii: {
    1: "4px",
    2: "6px",
    3: "8px",
    4: "12px",
    round: "50%",
    pill: "9999px"
  },
  transitions: {
    all: "all 200ms cubic-bezier(0.16, 1, 0.3, 1)"
  },
  zIndices: {
    1: "100",
    2: "200",
    3: "300",
    4: "400",
    max: "999"
  }
}, Ft = {
  xxs: "(max-width: 349px)",
  xs: "(max-width: 575px)",
  sm: "(max-width: 767px)",
  md: "(max-width: 991px)",
  lg: "(max-width: 90rem)",
  xl: "(min-width: calc(90rem + 1px))"
}, { styled: m, css: gi, keyframes: yi, createTheme: bi } = nt({
  theme: zt,
  media: Ft
}), kt = m("div", {
  display: "flex",
  flexDirection: "column",
  alignItems: "center"
}), Vt = m("p", {
  fontWeight: "bold"
}), Bt = m("span", {}), Ht = ({ error: e }) => {
  const { message: t } = e;
  return /* @__PURE__ */ a.createElement(kt, { role: "alert" }, /* @__PURE__ */ a.createElement(Vt, { "data-testid": "headline" }, "Something went wrong"), t && /* @__PURE__ */ a.createElement(Bt, null, `Error message: ${t}`, " "));
}, U = m("div", {
  display: "flex",
  background: "none",
  border: "none",
  width: "2rem !important",
  height: "2rem !important",
  padding: "0",
  margin: "0",
  borderRadius: "2rem",
  backgroundColor: "$accent",
  color: "$secondary",
  cursor: "pointer",
  boxSizing: "content-box !important",
  transition: "$all",
  justifyContent: "center",
  alignItems: "center",
  svg: {
    height: "60%",
    width: "60%",
    fill: "$secondary",
    stroke: "$secondary",
    opacity: "1",
    filter: "drop-shadow(5px 5px 5px #000D)",
    transition: "$all"
  }
}), le = m("button", {
  zIndex: "1",
  border: "none",
  cursor: "pointer",
  background: "transparent",
  marginLeft: "$2",
  padding: "0",
  "&:disabled": {
    [`> ${U}`]: {
      backgroundColor: "#6663",
      boxShadow: "none",
      svg: {
        fill: "$secondary",
        stroke: "$secondary",
        filter: "unset"
      }
    }
  },
  "&:hover:enabled": {
    [`> ${U}`]: {
      backgroundColor: "$accentAlt",
      boxShadow: "3px 3px 11px #0003",
      "&:disabled": {
        boxShadow: "unset"
      }
    }
  }
}), Wt = m("div", {
  display: "flex",
  flexDirection: "column"
}), qt = m("div", {
  display: "flex",
  flexDirection: "row",
  alignItems: "center",
  paddingLeft: "$5",
  paddingRight: "$4",
  "@xs": {
    width: "100%",
    justifyContent: "center",
    padding: "$4 $1 0 0"
  }
}), Ut = m("div", {
  display: "flex",
  flexDirection: "row",
  justifyContent: "space-between",
  paddingBottom: "$4",
  margin: "0",
  lineHeight: "1.4em",
  alignItems: "flex-end",
  "@xs": {
    flexDirection: "column"
  },
  ".clover-slider-header-homepage": {
    textDecoration: "none"
  },
  ".clover-slider-header-label": {
    fontSize: "1.25rem",
    fontWeight: "400"
  },
  ".clover-slider-header-summary": {
    fontSize: "$4",
    marginTop: "$2"
  }
}), Gt = (e, t = "none") => {
  if (!e) return null;
  if (typeof e == "string") return [e];
  if (!e[t]) {
    const r = Object.getOwnPropertyNames(e);
    if (r.length > 0) return e[r[0]];
  }
  return !e[t] || !Array.isArray(e[t]) ? null : e[t];
}, J = (e, t = "none", r = ", ") => {
  const n = Gt(e, t);
  return Array.isArray(n) ? n.join(`${r}`) : n;
};
function Jt(e) {
  return { __html: Kt(e) };
}
function B(e, t) {
  const r = Object.keys(e).filter(
    (o) => t.includes(o) ? null : o
  ), n = new Object();
  return r.forEach((o) => {
    n[o] = e[o];
  }), n;
}
function Kt(e) {
  return it(e, {
    allowedAttributes: {
      a: ["href"],
      img: ["alt", "src", "height", "width"]
    },
    allowedSchemes: ["http", "https", "mailto"],
    allowedTags: [
      "a",
      "b",
      "br",
      "i",
      "img",
      "p",
      "small",
      "span",
      "sub",
      "sup"
    ]
  });
}
const Zt = m("span", {}), X = (e) => {
  const { as: t, label: r } = e, o = B(e, ["as", "label"]);
  return /* @__PURE__ */ a.createElement(Zt, { as: t, ...o }, J(r, o.lang));
}, Qt = (e, t = "200,", r = "full") => {
  Array.isArray(e) && (e = e[0]);
  const { id: n, service: o } = e;
  let i;
  if (!o) return n;
  if (Array.isArray(e.service) && e.service.length > 0 && (i = o[0]), i) {
    if (i["@id"])
      return `${i["@id"]}/${r}/${t}/0/default.jpg`;
    if (i.id)
      return `${i.id}/${r}/${t}/0/default.jpg`;
  }
}, ce = m("img", { objectFit: "cover" }), Xt = (e) => {
  const t = w(null), { contentResource: r, altAsLabel: n, region: o = "full" } = e;
  let i;
  n && (i = J(n));
  const p = B(e, ["contentResource", "altAsLabel"]), { type: s, id: c, width: d = 200, height: h = 200, duration: v } = r;
  j(() => {
    if (!c && !t.current || ["Image"].includes(s) || !c.includes("m3u8")) return;
    const g = new H();
    return t.current && (g.attachMedia(t.current), g.on(H.Events.MEDIA_ATTACHED, function() {
      g.loadSource(c);
    })), g.on(H.Events.ERROR, function(y, f) {
      if (f.fatal)
        switch (f.type) {
          case H.ErrorTypes.NETWORK_ERROR:
            console.error(
              `fatal ${y} network error encountered, try to recover`
            ), g.startLoad();
            break;
          case H.ErrorTypes.MEDIA_ERROR:
            console.error(
              `fatal ${y} media error encountered, try to recover`
            ), g.recoverMediaError();
            break;
          default:
            g.destroy();
            break;
        }
    }), () => {
      g && (g.detachMedia(), g.destroy());
    };
  }, [c, s]);
  const b = Ye(() => {
    if (!t.current) return;
    let g = 0, y = 30;
    if (v && (y = v), !c.split("#t=") && v && (g = v * 0.1), c.split("#t=").pop()) {
      const S = c.split("#t=").pop();
      S && (g = parseInt(S.split(",")[0]));
    }
    const f = t.current;
    f.autoplay = !0, f.currentTime = g, setTimeout(() => b(), y * 1e3);
  }, [v, c]);
  j(() => b(), [b]);
  const A = Qt(
    r,
    `${d},${h}`,
    o
  );
  switch (s) {
    case "Image":
      return /* @__PURE__ */ a.createElement(
        ce,
        {
          as: "img",
          alt: i,
          css: { width: d, height: h },
          key: c,
          src: A,
          ...p
        }
      );
    case "Video":
      return /* @__PURE__ */ a.createElement(
        ce,
        {
          as: "video",
          css: { width: d, height: h },
          disablePictureInPicture: !0,
          key: c,
          loop: !0,
          muted: !0,
          onPause: b,
          ref: t,
          src: c
        }
      );
    default:
      return console.warn(
        `Resource type: ${s} is not valid or not yet supported in Primitives.`
      ), /* @__PURE__ */ a.createElement(a.Fragment, null);
  }
}, Yt = m("a", {}), we = (e) => {
  const { children: t, homepage: r } = e, o = B(e, ["children", "homepage"]);
  return /* @__PURE__ */ a.createElement(a.Fragment, null, r && r.map((i) => {
    const l = J(
      i.label,
      o.lang
    );
    return /* @__PURE__ */ a.createElement(
      Yt,
      {
        "aria-label": t ? l : void 0,
        href: i.id,
        key: i.id,
        ...o
      },
      t || l
    );
  }));
}, er = {
  delimiter: ", "
}, ie = ne(void 0), tr = () => {
  const e = et(ie);
  if (e === void 0)
    throw new Error(
      "usePrimitivesContext must be used with a PrimitivesProvider"
    );
  return e;
}, rr = ({
  children: e,
  initialState: t = er
}) => {
  const r = nr(t, "delimiter");
  return /* @__PURE__ */ a.createElement(ie.Provider, { value: { delimiter: r } }, e);
}, nr = (e, t) => Object.hasOwn(e, t) ? e[t].toString() : void 0, ir = m("span", {}), ue = (e) => {
  const { as: t, markup: r } = e, { delimiter: n } = tr();
  if (!r) return /* @__PURE__ */ a.createElement(a.Fragment, null);
  const i = B(e, ["as", "markup"]), l = Jt(
    J(r, i.lang, n)
  );
  return /* @__PURE__ */ a.createElement(ir, { as: t, ...i, dangerouslySetInnerHTML: l });
}, or = (e) => a.useContext(ie) ? /* @__PURE__ */ a.createElement(ue, { ...e }) : /* @__PURE__ */ a.createElement(rr, null, /* @__PURE__ */ a.createElement(ue, { ...e }));
m("span", {});
m("dl", {});
m("li", {});
m("ul", {});
m("li", {});
m("ul", {});
m("dl", {});
m("li", {});
m("ul", {});
const Se = (e) => {
  const { as: t, summary: r } = e, o = B(e, ["as", "customValueDelimiter", "summary"]);
  return /* @__PURE__ */ a.createElement(or, { as: t, markup: r, ...o });
}, ar = (e) => {
  const { thumbnail: t, region: r } = e, o = B(e, ["thumbnail"]);
  return /* @__PURE__ */ a.createElement(a.Fragment, null, t && t.map((i) => /* @__PURE__ */ a.createElement(
    Xt,
    {
      contentResource: i,
      key: i.id,
      region: r,
      ...o
    }
  )));
}, sr = () => /* @__PURE__ */ a.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 512 512" }, /* @__PURE__ */ a.createElement("title", null, "Next"), /* @__PURE__ */ a.createElement(
  "path",
  {
    fill: "none",
    stroke: "currentColor",
    strokeLinecap: "round",
    strokeLinejoin: "round",
    strokeMiterlimit: "10",
    strokeWidth: "45",
    d: "M268 112l144 144-144 144M392 256H100"
  }
)), lr = () => /* @__PURE__ */ a.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 512 512" }, /* @__PURE__ */ a.createElement("title", null, "Previous"), /* @__PURE__ */ a.createElement(
  "path",
  {
    fill: "none",
    stroke: "currentColor",
    strokeLinecap: "round",
    strokeLinejoin: "round",
    strokeMiterlimit: "10",
    strokeWidth: "45",
    d: "M244 400L100 256l144-144M120 256h292"
  }
)), cr = m(we, {
  display: "flex",
  backgroundColor: "$accent",
  color: "$secondary",
  height: "2rem !important",
  padding: "0 $3",
  margin: "0 0 0 $3",
  borderRadius: "2rem",
  cursor: "pointer",
  boxSizing: "content-box !important",
  transition: "$all",
  justifyContent: "center",
  alignItems: "center",
  lineBreak: "none",
  whiteSpace: "nowrap",
  textDecoration: "none !important",
  fontSize: "0.8333rem",
  "&:hover": {
    backgroundColor: "$accentAlt",
    boxShadow: "3px 3px 11px #0003",
    "&:disabled": {
      boxShadow: "unset"
    }
  }
}), ur = (e) => {
  const { t } = ge();
  return /* @__PURE__ */ a.createElement(cr, { ...e }, t("commonViewAll"));
}, pr = ({
  homepage: e,
  instance: t,
  label: r,
  summary: n
}) => {
  const { t: o } = ge(), [i, l] = $(!1);
  return j(() => {
    e && (e == null ? void 0 : e.length) > 0 && l(!0);
  }, [e]), /* @__PURE__ */ a.createElement(Ut, { "data-testid": "slider-header" }, /* @__PURE__ */ a.createElement(Wt, null, i ? /* @__PURE__ */ a.createElement(
    we,
    {
      homepage: e,
      className: "clover-slider-header-homepage"
    },
    /* @__PURE__ */ a.createElement(
      X,
      {
        label: r,
        as: "span",
        className: "clover-slider-header-label"
      }
    )
  ) : /* @__PURE__ */ a.createElement(
    X,
    {
      label: r,
      as: "span",
      className: "clover-slider-header-label"
    }
  ), n && /* @__PURE__ */ a.createElement(
    Se,
    {
      summary: n,
      as: "span",
      className: "clover-slider-header-summary"
    }
  )), /* @__PURE__ */ a.createElement(qt, null, /* @__PURE__ */ a.createElement(
    le,
    {
      className: `clover-slider-previous-${t}`,
      "aria-label": o("commonPrevious")
    },
    /* @__PURE__ */ a.createElement(U, null, /* @__PURE__ */ a.createElement(lr, null))
  ), /* @__PURE__ */ a.createElement(
    le,
    {
      className: `clover-slider-next-${t}`,
      "aria-label": o("commonNext")
    },
    /* @__PURE__ */ a.createElement(U, null, /* @__PURE__ */ a.createElement(sr, null))
  ), i && /* @__PURE__ */ a.createElement(
    ur,
    {
      homepage: e,
      className: "clover-slider-header-view-all"
    }
  )));
};
function k(e) {
  return typeof e == "object" && e !== null && e.constructor && Object.prototype.toString.call(e).slice(8, -1) === "Object";
}
function T(e, t) {
  const r = ["__proto__", "constructor", "prototype"];
  Object.keys(t).filter((n) => r.indexOf(n) < 0).forEach((n) => {
    typeof e[n] > "u" ? e[n] = t[n] : k(t[n]) && k(e[n]) && Object.keys(t[n]).length > 0 ? t[n].__swiper__ ? e[n] = t[n] : T(e[n], t[n]) : e[n] = t[n];
  });
}
function Ce(e = {}) {
  return e.navigation && typeof e.navigation.nextEl > "u" && typeof e.navigation.prevEl > "u";
}
function Ee(e = {}) {
  return e.pagination && typeof e.pagination.el > "u";
}
function Ae(e = {}) {
  return e.scrollbar && typeof e.scrollbar.el > "u";
}
function $e(e = "") {
  const t = e.split(" ").map((n) => n.trim()).filter((n) => !!n), r = [];
  return t.forEach((n) => {
    r.indexOf(n) < 0 && r.push(n);
  }), r.join(" ");
}
function fr(e = "") {
  return e ? e.includes("swiper-wrapper") ? e : `swiper-wrapper ${e}` : "swiper-wrapper";
}
const Re = [
  "eventsPrefix",
  "injectStyles",
  "injectStylesUrls",
  "modules",
  "init",
  "_direction",
  "oneWayMovement",
  "touchEventsTarget",
  "initialSlide",
  "_speed",
  "cssMode",
  "updateOnWindowResize",
  "resizeObserver",
  "nested",
  "focusableElements",
  "_enabled",
  "_width",
  "_height",
  "preventInteractionOnTransition",
  "userAgent",
  "url",
  "_edgeSwipeDetection",
  "_edgeSwipeThreshold",
  "_freeMode",
  "_autoHeight",
  "setWrapperSize",
  "virtualTranslate",
  "_effect",
  "breakpoints",
  "_spaceBetween",
  "_slidesPerView",
  "maxBackfaceHiddenSlides",
  "_grid",
  "_slidesPerGroup",
  "_slidesPerGroupSkip",
  "_slidesPerGroupAuto",
  "_centeredSlides",
  "_centeredSlidesBounds",
  "_slidesOffsetBefore",
  "_slidesOffsetAfter",
  "normalizeSlideIndex",
  "_centerInsufficientSlides",
  "_watchOverflow",
  "roundLengths",
  "touchRatio",
  "touchAngle",
  "simulateTouch",
  "_shortSwipes",
  "_longSwipes",
  "longSwipesRatio",
  "longSwipesMs",
  "_followFinger",
  "allowTouchMove",
  "_threshold",
  "touchMoveStopPropagation",
  "touchStartPreventDefault",
  "touchStartForcePreventDefault",
  "touchReleaseOnEdges",
  "uniqueNavElements",
  "_resistance",
  "_resistanceRatio",
  "_watchSlidesProgress",
  "_grabCursor",
  "preventClicks",
  "preventClicksPropagation",
  "_slideToClickedSlide",
  "_loop",
  "loopedSlides",
  "loopPreventsSliding",
  "_rewind",
  "_allowSlidePrev",
  "_allowSlideNext",
  "_swipeHandler",
  "_noSwiping",
  "noSwipingClass",
  "noSwipingSelector",
  "passiveListeners",
  "containerModifierClass",
  "slideClass",
  "slideActiveClass",
  "slideVisibleClass",
  "slideNextClass",
  "slidePrevClass",
  "wrapperClass",
  "lazyPreloaderClass",
  "lazyPreloadPrevNext",
  "runCallbacksOnInit",
  "observer",
  "observeParents",
  "observeSlideChildren",
  // modules
  "a11y",
  "_autoplay",
  "_controller",
  "coverflowEffect",
  "cubeEffect",
  "fadeEffect",
  "flipEffect",
  "creativeEffect",
  "cardsEffect",
  "hashNavigation",
  "history",
  "keyboard",
  "mousewheel",
  "_navigation",
  "_pagination",
  "parallax",
  "_scrollbar",
  "_thumbs",
  "virtual",
  "zoom",
  "control"
];
function dr(e = {}, t = !0) {
  const r = {
    on: {}
  }, n = {}, o = {};
  T(r, Z.defaults), T(r, Z.extendedDefaults), r._emitClasses = !0, r.init = !1;
  const i = {}, l = Re.map((s) => s.replace(/_/, "")), p = Object.assign({}, e);
  return Object.keys(p).forEach((s) => {
    typeof e[s] > "u" || (l.indexOf(s) >= 0 ? k(e[s]) ? (r[s] = {}, o[s] = {}, T(r[s], e[s]), T(o[s], e[s])) : (r[s] = e[s], o[s] = e[s]) : s.search(/on[A-Z]/) === 0 && typeof e[s] == "function" ? t ? n[`${s[2].toLowerCase()}${s.substr(3)}`] = e[s] : r.on[`${s[2].toLowerCase()}${s.substr(3)}`] = e[s] : i[s] = e[s]);
  }), ["navigation", "pagination", "scrollbar"].forEach((s) => {
    r[s] === !0 && (r[s] = {}), r[s] === !1 && delete r[s];
  }), {
    params: r,
    passedParams: o,
    rest: i,
    events: n
  };
}
function hr({
  el: e,
  nextEl: t,
  prevEl: r,
  paginationEl: n,
  scrollbarEl: o,
  swiper: i
}, l) {
  Ce(l) && t && r && (i.params.navigation.nextEl = t, i.originalParams.navigation.nextEl = t, i.params.navigation.prevEl = r, i.originalParams.navigation.prevEl = r), Ee(l) && n && (i.params.pagination.el = n, i.originalParams.pagination.el = n), Ae(l) && o && (i.params.scrollbar.el = o, i.originalParams.scrollbar.el = o), i.init(e);
}
function mr(e, t, r, n, o) {
  const i = [];
  if (!t) return i;
  const l = (s) => {
    i.indexOf(s) < 0 && i.push(s);
  };
  if (r && n) {
    const s = n.map(o), c = r.map(o);
    s.join("") !== c.join("") && l("children"), n.length !== r.length && l("children");
  }
  return Re.filter((s) => s[0] === "_").map((s) => s.replace(/_/, "")).forEach((s) => {
    if (s in e && s in t)
      if (k(e[s]) && k(t[s])) {
        const c = Object.keys(e[s]), d = Object.keys(t[s]);
        c.length !== d.length ? l(s) : (c.forEach((h) => {
          e[s][h] !== t[s][h] && l(s);
        }), d.forEach((h) => {
          e[s][h] !== t[s][h] && l(s);
        }));
      } else e[s] !== t[s] && l(s);
  }), i;
}
function Ie(e) {
  return e.type && e.type.displayName && e.type.displayName.includes("SwiperSlide");
}
function Le(e) {
  const t = [];
  return a.Children.toArray(e).forEach((r) => {
    Ie(r) ? t.push(r) : r.props && r.props.children && Le(r.props.children).forEach((n) => t.push(n));
  }), t;
}
function vr(e) {
  const t = [], r = {
    "container-start": [],
    "container-end": [],
    "wrapper-start": [],
    "wrapper-end": []
  };
  return a.Children.toArray(e).forEach((n) => {
    if (Ie(n))
      t.push(n);
    else if (n.props && n.props.slot && r[n.props.slot])
      r[n.props.slot].push(n);
    else if (n.props && n.props.children) {
      const o = Le(n.props.children);
      o.length > 0 ? o.forEach((i) => t.push(i)) : r["container-end"].push(n);
    } else
      r["container-end"].push(n);
  }), {
    slides: t,
    slots: r
  };
}
function gr({
  swiper: e,
  slides: t,
  passedParams: r,
  changedParams: n,
  nextEl: o,
  prevEl: i,
  scrollbarEl: l,
  paginationEl: p
}) {
  const s = n.filter((u) => u !== "children" && u !== "direction" && u !== "wrapperClass"), {
    params: c,
    pagination: d,
    navigation: h,
    scrollbar: v,
    virtual: b,
    thumbs: A
  } = e;
  let g, y, f, S, M, _, L, C;
  n.includes("thumbs") && r.thumbs && r.thumbs.swiper && c.thumbs && !c.thumbs.swiper && (g = !0), n.includes("controller") && r.controller && r.controller.control && c.controller && !c.controller.control && (y = !0), n.includes("pagination") && r.pagination && (r.pagination.el || p) && (c.pagination || c.pagination === !1) && d && !d.el && (f = !0), n.includes("scrollbar") && r.scrollbar && (r.scrollbar.el || l) && (c.scrollbar || c.scrollbar === !1) && v && !v.el && (S = !0), n.includes("navigation") && r.navigation && (r.navigation.prevEl || i) && (r.navigation.nextEl || o) && (c.navigation || c.navigation === !1) && h && !h.prevEl && !h.nextEl && (M = !0);
  const V = (u) => {
    e[u] && (e[u].destroy(), u === "navigation" ? (e.isElement && (e[u].prevEl.remove(), e[u].nextEl.remove()), c[u].prevEl = void 0, c[u].nextEl = void 0, e[u].prevEl = void 0, e[u].nextEl = void 0) : (e.isElement && e[u].el.remove(), c[u].el = void 0, e[u].el = void 0));
  };
  n.includes("loop") && e.isElement && (c.loop && !r.loop ? _ = !0 : !c.loop && r.loop ? L = !0 : C = !0), s.forEach((u) => {
    if (k(c[u]) && k(r[u]))
      T(c[u], r[u]), (u === "navigation" || u === "pagination" || u === "scrollbar") && "enabled" in r[u] && !r[u].enabled && V(u);
    else {
      const N = r[u];
      (N === !0 || N === !1) && (u === "navigation" || u === "pagination" || u === "scrollbar") ? N === !1 && V(u) : c[u] = r[u];
    }
  }), s.includes("controller") && !y && e.controller && e.controller.control && c.controller && c.controller.control && (e.controller.control = c.controller.control), n.includes("children") && t && b && c.virtual.enabled && (b.slides = t, b.update(!0)), n.includes("children") && t && c.loop && (C = !0), g && A.init() && A.update(!0), y && (e.controller.control = c.controller.control), f && (e.isElement && (!p || typeof p == "string") && (p = document.createElement("div"), p.classList.add("swiper-pagination"), e.el.shadowEl.appendChild(p)), p && (c.pagination.el = p), d.init(), d.render(), d.update()), S && (e.isElement && (!l || typeof l == "string") && (l = document.createElement("div"), l.classList.add("swiper-scrollbar"), e.el.shadowEl.appendChild(l)), l && (c.scrollbar.el = l), v.init(), v.updateSize(), v.setTranslate()), M && (e.isElement && ((!o || typeof o == "string") && (o = document.createElement("div"), o.classList.add("swiper-button-next"), e.el.shadowEl.appendChild(o)), (!i || typeof i == "string") && (i = document.createElement("div"), i.classList.add("swiper-button-prev"), e.el.shadowEl.appendChild(i))), o && (c.navigation.nextEl = o), i && (c.navigation.prevEl = i), h.init(), h.update()), n.includes("allowSlideNext") && (e.allowSlideNext = r.allowSlideNext), n.includes("allowSlidePrev") && (e.allowSlidePrev = r.allowSlidePrev), n.includes("direction") && e.changeDirection(r.direction, !1), (_ || C) && e.loopDestroy(), (L || C) && e.loopCreate(), e.update();
}
function yr(e, t, r) {
  if (!r) return null;
  const n = (d) => {
    let h = d;
    return d < 0 ? h = t.length + d : h >= t.length && (h = h - t.length), h;
  }, o = e.isHorizontal() ? {
    [e.rtlTranslate ? "right" : "left"]: `${r.offset}px`
  } : {
    top: `${r.offset}px`
  }, {
    from: i,
    to: l
  } = r, p = e.params.loop ? -t.length : 0, s = e.params.loop ? t.length * 2 : t.length, c = [];
  for (let d = p; d < s; d += 1)
    d >= i && d <= l && c.push(t[n(d)]);
  return c.map((d, h) => /* @__PURE__ */ a.cloneElement(d, {
    swiper: e,
    style: o,
    key: `slide-${h}`
  }));
}
const br = (e) => {
  !e || e.destroyed || !e.params.virtual || e.params.virtual && !e.params.virtual.enabled || (e.updateSlides(), e.updateProgress(), e.updateSlidesClasses(), e.parallax && e.params.parallax && e.params.parallax.enabled && e.parallax.setTranslate());
};
function W(e, t) {
  return typeof window > "u" ? j(e, t) : tt(e, t);
}
const pe = /* @__PURE__ */ ne(null), xr = /* @__PURE__ */ ne(null);
function Y() {
  return Y = Object.assign ? Object.assign.bind() : function(e) {
    for (var t = 1; t < arguments.length; t++) {
      var r = arguments[t];
      for (var n in r)
        Object.prototype.hasOwnProperty.call(r, n) && (e[n] = r[n]);
    }
    return e;
  }, Y.apply(this, arguments);
}
const Oe = /* @__PURE__ */ ye(function(e, t) {
  let {
    className: r,
    tag: n = "div",
    wrapperTag: o = "div",
    children: i,
    onSwiper: l,
    ...p
  } = e === void 0 ? {} : e, s = !1;
  const [c, d] = $("swiper"), [h, v] = $(null), [b, A] = $(!1), g = w(!1), y = w(null), f = w(null), S = w(null), M = w(null), _ = w(null), L = w(null), C = w(null), V = w(null), {
    params: u,
    passedParams: N,
    rest: Ue,
    events: D
  } = dr(p), {
    slides: z,
    slots: q
  } = vr(i), ae = () => {
    A(!b);
  };
  Object.assign(u.on, {
    _containerClasses(x, O) {
      d(O);
    }
  });
  const se = () => {
    Object.assign(u.on, D), s = !0;
    const x = {
      ...u
    };
    if (delete x.wrapperClass, f.current = new Z(x), f.current.virtual && f.current.params.virtual.enabled) {
      f.current.virtual.slides = z;
      const O = {
        cache: !1,
        slides: z,
        renderExternal: v,
        renderExternalUpdate: !1
      };
      T(f.current.params.virtual, O), T(f.current.originalParams.virtual, O);
    }
  };
  y.current || se(), f.current && f.current.on("_beforeBreakpoint", ae);
  const Ge = () => {
    s || !D || !f.current || Object.keys(D).forEach((x) => {
      f.current.on(x, D[x]);
    });
  }, Je = () => {
    !D || !f.current || Object.keys(D).forEach((x) => {
      f.current.off(x, D[x]);
    });
  };
  j(() => () => {
    f.current && f.current.off("_beforeBreakpoint", ae);
  }), j(() => {
    !g.current && f.current && (f.current.emitSlidesClasses(), g.current = !0);
  }), W(() => {
    if (t && (t.current = y.current), !!y.current)
      return f.current.destroyed && se(), hr({
        el: y.current,
        nextEl: _.current,
        prevEl: L.current,
        paginationEl: C.current,
        scrollbarEl: V.current,
        swiper: f.current
      }, u), l && l(f.current), () => {
        f.current && !f.current.destroyed && f.current.destroy(!0, !1);
      };
  }, []), W(() => {
    Ge();
    const x = mr(N, S.current, z, M.current, (O) => O.key);
    return S.current = N, M.current = z, x.length && f.current && !f.current.destroyed && gr({
      swiper: f.current,
      slides: z,
      passedParams: N,
      changedParams: x,
      nextEl: _.current,
      prevEl: L.current,
      scrollbarEl: V.current,
      paginationEl: C.current
    }), () => {
      Je();
    };
  }), W(() => {
    br(f.current);
  }, [h]);
  function Ke() {
    return u.virtual ? yr(f.current, z, h) : z.map((x, O) => /* @__PURE__ */ a.cloneElement(x, {
      swiper: f.current,
      swiperSlideIndex: O
    }));
  }
  return /* @__PURE__ */ a.createElement(n, Y({
    ref: y,
    className: $e(`${c}${r ? ` ${r}` : ""}`)
  }, Ue), /* @__PURE__ */ a.createElement(xr.Provider, {
    value: f.current
  }, q["container-start"], /* @__PURE__ */ a.createElement(o, {
    className: fr(u.wrapperClass)
  }, q["wrapper-start"], Ke(), q["wrapper-end"]), Ce(u) && /* @__PURE__ */ a.createElement(a.Fragment, null, /* @__PURE__ */ a.createElement("div", {
    ref: L,
    className: "swiper-button-prev"
  }), /* @__PURE__ */ a.createElement("div", {
    ref: _,
    className: "swiper-button-next"
  })), Ae(u) && /* @__PURE__ */ a.createElement("div", {
    ref: V,
    className: "swiper-scrollbar"
  }), Ee(u) && /* @__PURE__ */ a.createElement("div", {
    ref: C,
    className: "swiper-pagination"
  }), q["container-end"]));
});
Oe.displayName = "Swiper";
function ee() {
  return ee = Object.assign ? Object.assign.bind() : function(e) {
    for (var t = 1; t < arguments.length; t++) {
      var r = arguments[t];
      for (var n in r)
        Object.prototype.hasOwnProperty.call(r, n) && (e[n] = r[n]);
    }
    return e;
  }, ee.apply(this, arguments);
}
const Te = /* @__PURE__ */ ye(function(e, t) {
  let {
    tag: r = "div",
    children: n,
    className: o = "",
    swiper: i,
    zoom: l,
    lazy: p,
    virtualIndex: s,
    swiperSlideIndex: c,
    ...d
  } = e === void 0 ? {} : e;
  const h = w(null), [v, b] = $("swiper-slide"), [A, g] = $(!1);
  function y(_, L, C) {
    L === h.current && b(C);
  }
  W(() => {
    if (typeof c < "u" && (h.current.swiperSlideIndex = c), t && (t.current = h.current), !(!h.current || !i)) {
      if (i.destroyed) {
        v !== "swiper-slide" && b("swiper-slide");
        return;
      }
      return i.on("_slideClass", y), () => {
        i && i.off("_slideClass", y);
      };
    }
  }), W(() => {
    i && h.current && !i.destroyed && b(i.getSlideClasses(h.current));
  }, [i]);
  const f = {
    isActive: v.indexOf("swiper-slide-active") >= 0,
    isVisible: v.indexOf("swiper-slide-visible") >= 0,
    isPrev: v.indexOf("swiper-slide-prev") >= 0,
    isNext: v.indexOf("swiper-slide-next") >= 0
  }, S = () => typeof n == "function" ? n(f) : n, M = () => {
    g(!0);
  };
  return /* @__PURE__ */ a.createElement(r, ee({
    ref: h,
    className: $e(`${v}${o ? ` ${o}` : ""}`),
    "data-swiper-slide-index": s,
    onLoad: M
  }, d), l && /* @__PURE__ */ a.createElement(pe.Provider, {
    value: f
  }, /* @__PURE__ */ a.createElement("div", {
    className: "swiper-zoom-container",
    "data-swiper-zoom": typeof l == "number" ? l : void 0
  }, S(), p && !A && /* @__PURE__ */ a.createElement("div", {
    className: "swiper-lazy-preloader"
  }))), !l && /* @__PURE__ */ a.createElement(pe.Provider, {
    value: f
  }, S(), p && !A && /* @__PURE__ */ a.createElement("div", {
    className: "swiper-lazy-preloader"
  })));
});
Te.displayName = "SwiperSlide";
const wr = m("a", {
  textDecoration: "none"
}), Sr = m("div", {
  position: "relative",
  zIndex: "0",
  borderRadius: "3px"
}), Cr = m("div", {
  position: "absolute",
  width: "100%",
  backgroundColor: "green"
}), Er = m("figure", {
  display: "flex",
  flexDirection: "column",
  margin: "0 0 $2",
  flexGrow: "0",
  flexShrink: "0",
  borderRadius: "3px",
  transition: "$all",
  img: {
    position: "absolute",
    display: "flex",
    flexDirection: "column",
    objectFit: "cover",
    zIndex: "0",
    width: "100%",
    height: "100%",
    color: "transparent"
  },
  video: {
    position: "absolute",
    display: "flex",
    flexDirection: "column",
    objectFit: "cover",
    zIndex: "1",
    width: "100%",
    height: "100%",
    color: "transparent",
    opacity: "0",
    transition: "$load",
    borderRadius: "3px"
  },
  figcaption: {
    display: "flex",
    flexDirection: "column",
    padding: "$2 0",
    transition: "$all"
  },
  variants: {
    isFocused: {
      true: {
        video: {
          opacity: "1"
        },
        figcaption: {
          color: "$accent"
        }
      }
    }
  }
}), Ar = m("span", {
  display: "flex",
  position: "relative",
  width: "100%",
  height: "100%",
  overflow: "hidden",
  borderRadius: "3px",
  boxShadow: "none",
  transition: "$all"
}), $r = m(X, {
  fontSize: "$3",
  fontWeight: "700"
}), Rr = m(Se, {
  fontSize: "$2",
  marginTop: "$1"
}), Ir = ({
  isFocused: e,
  label: t,
  summary: r,
  thumbnail: n
}) => {
  const o = w(null);
  return /* @__PURE__ */ a.createElement(Er, { isFocused: e }, /* @__PURE__ */ a.createElement(be.Root, { ratio: 1 / 1 }, /* @__PURE__ */ a.createElement(Cr, { ref: o }), /* @__PURE__ */ a.createElement(Ar, null, /* @__PURE__ */ a.createElement(
    ar,
    {
      altAsLabel: t,
      thumbnail: n,
      "data-testid": "figure-thumbnail"
    }
  ))), /* @__PURE__ */ a.createElement("figcaption", null, /* @__PURE__ */ a.createElement($r, { label: t }), r && /* @__PURE__ */ a.createElement(Rr, { summary: r })));
}, Lr = ({ backgroundImage: e }) => /* @__PURE__ */ a.createElement(Tr, { "data-testid": "slider-item-placeholder" }, /* @__PURE__ */ a.createElement(
  Or,
  {
    ratio: 1 / 1,
    css: {
      backgroundImage: `url(${e})`
    }
  }
)), Or = m(be.Root, {
  backgroundSize: "cover",
  backgroundRepeat: "no-repeat",
  backgroundPosition: "50% 50%",
  filter: "blur(3em)",
  opacity: "0.7"
}), Tr = m("div", {
  position: "absolute",
  width: "100%",
  overflow: "hidden",
  backgroundColor: "#716C6B"
}), jr = ({ handleItemInteraction: e, index: t, item: r }) => {
  var d, h;
  const [n, o] = $(!1);
  let i = [], l = "#";
  r != null && r.thumbnail && ((d = r == null ? void 0 : r.thumbnail) == null ? void 0 : d.length) > 0 && (i = r.thumbnail), r != null && r.homepage && ((h = r.homepage) == null ? void 0 : h.length) > 0 && (l = r.homepage[0].id);
  const p = () => o(!0), s = () => o(!1), c = (v) => {
    e && (v.preventDefault(), e(r));
  };
  return /* @__PURE__ */ a.createElement(Sr, { "data-testid": "slider-item" }, /* @__PURE__ */ a.createElement(
    wr,
    {
      "data-testid": "slider-item-anchor",
      href: l,
      onClick: c,
      tabIndex: 0,
      onFocus: p,
      onBlur: s,
      onMouseEnter: p,
      onMouseLeave: s
    },
    /* @__PURE__ */ a.createElement(Lr, { backgroundImage: "" }),
    /* @__PURE__ */ a.createElement(
      Ir,
      {
        "data-testid": "slider-item-figure",
        index: t,
        isFocused: n,
        key: r.id,
        label: r.label,
        summary: r.summary,
        thumbnail: i
      }
    )
  ));
}, Pr = m("div", {
  "& .swiper-slide": {}
}), Mr = ({
  children: e,
  rootMargin: t = "100px",
  attributes: r = {},
  isVisibleCallback: n = () => {
  }
}) => {
  const o = w(null), [i, l] = $(!1);
  return j(() => {
    const p = o.current;
    if (!p) return;
    const s = new IntersectionObserver(
      ([c]) => {
        c.isIntersecting && (n(!0), l(!0), s.disconnect());
      },
      { rootMargin: t }
    );
    return s.observe(p), () => s.disconnect();
  }, [o]), /* @__PURE__ */ a.createElement("div", { ref: o, ...r }, i ? e : null);
}, _r = {
  640: {
    slidesPerView: 2,
    slidesPerGroup: 2,
    spaceBetween: 20
  },
  768: {
    slidesPerView: 3,
    slidesPerGroup: 3,
    spaceBetween: 30
  },
  1024: {
    slidesPerView: 4,
    slidesPerGroup: 4,
    spaceBetween: 40
  },
  1366: {
    slidesPerView: 5,
    slidesPerGroup: 5,
    spaceBetween: 50
  },
  1920: {
    slidesPerView: 6,
    slidesPerGroup: 6,
    spaceBetween: 60
  }
}, Nr = ({
  breakpoints: e = _r,
  handleItemInteraction: t,
  instance: r,
  items: n
}) => {
  const o = w(null);
  return /* @__PURE__ */ a.createElement(Pr, { ref: o }, /* @__PURE__ */ a.createElement(
    Oe,
    {
      a11y: {
        prevSlideMessage: "previous item",
        nextSlideMessage: "next item"
      },
      spaceBetween: 31,
      modules: [ot, at],
      navigation: {
        nextEl: `.clover-slider-next-${r}`,
        prevEl: `.clover-slider-previous-${r}`
      },
      slidesPerView: 2,
      slidesPerGroup: 2,
      breakpoints: e
    },
    n.map((i, l) => /* @__PURE__ */ a.createElement(
      Te,
      {
        key: `${i.id}-${l}`,
        "data-index": l,
        "data-type": i == null ? void 0 : i.type.toLowerCase()
      },
      /* @__PURE__ */ a.createElement(Mr, null, /* @__PURE__ */ a.createElement(
        jr,
        {
          handleItemInteraction: t,
          index: l,
          item: i
        }
      ))
    ))
  ));
}, Dr = (e) => {
  let t = 0;
  const r = e == null ? void 0 : e.length;
  let n = 0;
  if (r > 0) for (; n < r; ) t = (t << 5) - t + e.charCodeAt(n++) | 0;
  return t;
};
var zr = "http://library.stanford.edu/iiif/image-api/compliance.html#level0", Fr = "http://library.stanford.edu/iiif/image-api/compliance.html#level1", je = "http://library.stanford.edu/iiif/image-api/compliance.html#level2", kr = "http://library.stanford.edu/iiif/image-api/conformance.html#level0", Vr = "http://library.stanford.edu/iiif/image-api/conformance.html#level1", Pe = "http://library.stanford.edu/iiif/image-api/conformance.html#level2", Br = "http://library.stanford.edu/iiif/image-api/1.1/compliance.html#level0", Hr = "http://library.stanford.edu/iiif/image-api/1.1/compliance.html#level1", Me = "http://library.stanford.edu/iiif/image-api/1.1/compliance.html#level2", Wr = "http://library.stanford.edu/iiif/image-api/1.1/conformance.html#level0", qr = "http://library.stanford.edu/iiif/image-api/1.1/conformance.html#level1", _e = "http://library.stanford.edu/iiif/image-api/1.1/conformance.html#level2", Ur = "http://iiif.io/api/image/1/level0.json", Gr = "http://iiif.io/api/image/1/profiles/level0.json", Jr = "http://iiif.io/api/image/1/level1.json", Kr = "http://iiif.io/api/image/1/profiles/level1.json", Ne = "http://iiif.io/api/image/1/level2.json", De = "http://iiif.io/api/image/1/profiles/level2.json", Zr = "http://iiif.io/api/image/2/level0.json", Qr = "http://iiif.io/api/image/2/profiles/level0.json", Xr = "http://iiif.io/api/image/2/level1.json", Yr = "http://iiif.io/api/image/2/profiles/level1.json", ze = "http://iiif.io/api/image/2/level2.json", Fe = "http://iiif.io/api/image/2/profiles/level2.json", en = "level0", tn = "level1", ke = "level2", rn = "http://iiif.io/api/image/2/level0", nn = "http://iiif.io/api/image/2/level1", Ve = "http://iiif.io/api/image/2/level2", on = [Ve, je, Pe, Me, _e, Ne, De, ze, Fe, ke], an = [rn, nn, Ve, zr, Fr, je, kr, Vr, Pe, Br, Hr, Me, Wr, qr, _e, Ur, Gr, Jr, Kr, Ne, De, Zr, Qr, Xr, Yr, ze, Fe, en, tn, ke], sn = an;
function E(e) {
  for (let t in e) (typeof e[t] > "u" || e[t] === null) && delete e[t];
  return e;
}
function ln(e) {
  return Array.isArray(e) ? e : e ? [e] : [];
}
var cn = Object.defineProperty, un = (e, t, r) => t in e ? cn(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, fe = (e, t, r) => (un(e, typeof t != "symbol" ? t + "" : t, r), r), de = ["sc:Collection", "sc:Manifest", "sc:Canvas", "sc:AnnotationList", "oa:Annotation", "sc:Range", "sc:Layer", "sc:Sequence", "oa:Choice", "Service", "ContentResource"];
function pn(e) {
  if (typeof e > "u" || e === null) throw new Error("Null or undefined is not a valid entity.");
  if (Array.isArray(e)) throw new Error("Array is not a valid entity");
  if (typeof e != "object") throw new Error(`${typeof e} is not a valid entity`);
  if (typeof e["@type"] == "string") {
    let t = de.indexOf(e["@type"]);
    if (t !== -1) return de[t];
  }
  if (e.profile) return "Service";
  if (e.format || e["@type"]) return "ContentResource";
  throw new Error("Resource type is not known");
}
var fn = class Be {
  constructor(t, r = {}) {
    fe(this, "traversals"), fe(this, "options"), this.traversals = { collection: [], manifest: [], canvas: [], annotationList: [], sequence: [], annotation: [], contentResource: [], choice: [], range: [], service: [], layer: [], ...t }, this.options = { convertPropsToArray: !0, mergeMemberProperties: !0, allowUndefinedReturn: !1, ...r };
  }
  static all(t) {
    return new Be({ collection: [t], manifest: [t], canvas: [t], annotationList: [t], sequence: [t], annotation: [t], contentResource: [t], choice: [t], range: [t], service: [t], layer: [t] });
  }
  traverseCollection(t) {
    return this.traverseType(this.traverseDescriptive(this.traverseLinking(this.traverseCollectionItems(t))), this.traversals.collection);
  }
  traverseCollectionItems(t) {
    if (this.options.mergeMemberProperties) {
      let r = [...(t.manifests || []).map((n) => typeof n == "string" ? { "@id": n, "@type": "sc:Manifest" } : n), ...(t.collections || []).map((n) => typeof n == "string" ? { "@id": n, "@type": "sc:Collection" } : n), ...t.members || []];
      delete t.collections, delete t.manifests, t.members = r;
    }
    return t.manifests && (t.manifests = t.manifests.map((r) => this.traverseManifest(typeof r == "string" ? { "@id": r, "@type": "sc:Manifest" } : r))), t.collections && (t.collections = t.collections.map((r) => this.traverseCollection(typeof r == "string" ? { "@id": r, "@type": "sc:Collection" } : r))), t.members && (t.members = t.members.map((r) => typeof r == "string" ? r : this.traverseUnknown(r))), t;
  }
  traverseManifest(t) {
    return this.traverseType(this.traverseDescriptive(this.traverseLinking(this.traverseManifestItems(t))), this.traversals.manifest);
  }
  traverseManifestItems(t) {
    return t.sequences && (t.sequences = t.sequences.map((r) => this.traverseSequence(r))), t.structures && (t.structures = t.structures.map((r) => this.traverseRange(r))), t;
  }
  traverseSequence(t) {
    return this.traverseType(this.traverseDescriptive(this.traverseLinking(this.traverseSequenceItems(t))), this.traversals.sequence);
  }
  traverseSequenceItems(t) {
    return t.canvases && (t.canvases = t.canvases.map((r) => this.traverseCanvas(r))), t;
  }
  traverseCanvas(t) {
    return this.traverseType(this.traverseDescriptive(this.traverseLinking(this.traverseCanvasItems(t))), this.traversals.canvas);
  }
  traverseCanvasItems(t) {
    return t.images && (t.images = t.images.map((r) => this.traverseAnnotation(r))), t.otherContent && (t.otherContent = t.otherContent.map((r) => this.traverseAnnotationList(r))), t;
  }
  traverseRange(t) {
    return this.traverseType(this.traverseDescriptive(this.traverseLinking(this.traverseRangeItems(t))), this.traversals.range);
  }
  traverseRangeItems(t) {
    if (this.options.mergeMemberProperties) {
      let r = [...(t.ranges || []).map((n) => typeof n == "string" ? { "@id": n, "@type": "sc:Range" } : n), ...(t.canvases || []).map((n) => typeof n == "string" ? { "@id": n, "@type": "sc:Canvas" } : n), ...t.members || []];
      delete t.ranges, delete t.canvases, t.members = r.length ? r.map((n) => this.traverseUnknown(n)) : void 0;
    }
    return t;
  }
  traverseAnnotationList(t) {
    let r = typeof t == "string" ? { "@id": t, "@type": "sc:AnnotationList" } : t;
    return this.traverseType(this.traverseDescriptive(this.traverseAnnotationListItems(r)), this.traversals.annotationList);
  }
  traverseAnnotationListItems(t) {
    return t.resources && (t.resources = t.resources.map((r) => this.traverseAnnotation(r))), t;
  }
  traverseAnnotation(t) {
    return this.traverseType(this.traverseDescriptive(this.traverseLinking(this.traverseAnnotationItems(t))), this.traversals.annotation);
  }
  traverseAnnotationItems(t) {
    return t.resource && (Array.isArray(t.resource) ? t.resource = t.resource.map((r) => this.traverseContentResource(r)) : t.resource = this.traverseContentResource(t.resource)), t.on, t;
  }
  traverseLayer(t) {
    return this.traverseType(this.traverseLinking(this.traverseLayerItems(t)), this.traversals.layer);
  }
  traverseLayerItems(t) {
    return t.otherContent && (t.otherContent = t.otherContent.map((r) => this.traverseAnnotationList(r))), t;
  }
  traverseChoice(t) {
    return this.traverseType(this.traverseChoiceItems(t), this.traversals.choice);
  }
  traverseChoiceItems(t) {
    return t.default && t.default !== "rdf:nil" && (t.default = this.traverseContentResource(t.default)), t.item && t.item !== "rdf:nil" && (t.item = t.item.map((r) => this.traverseContentResource(r))), t;
  }
  traverseService(t) {
    return this.traverseType(this.traverseLinking(t), this.traversals.service);
  }
  traverseContentResource(t) {
    return t["@type"] === "oa:Choice" ? this.traverseChoice(t) : this.traverseType(this.traverseDescriptive(this.traverseLinking(t)), this.traversals.contentResource);
  }
  traverseUnknown(t) {
    if (!t["@type"] || typeof t == "string") return t;
    switch (pn(t)) {
      case "sc:Collection":
        return this.traverseCollection(t);
      case "sc:Manifest":
        return this.traverseManifest(t);
      case "sc:Canvas":
        return this.traverseCanvas(t);
      case "sc:Sequence":
        return this.traverseSequence(t);
      case "sc:Range":
        return this.traverseRange(t);
      case "oa:Annotation":
        return this.traverseAnnotation(t);
      case "sc:AnnotationList":
        return this.traverseAnnotationList(t);
      case "sc:Layer":
        return this.traverseLayer(t);
      case "Service":
        return this.traverseService(t);
      case "oa:Choice":
        return this.traverseChoice(t);
      case "ContentResource":
        return this.traverseContentResource(t);
    }
    return t.profile ? this.traverseService(t) : t;
  }
  traverseImageResource(t) {
    let r = Array.isArray(t), n = Array.isArray(t) ? t : [t], o = [];
    for (let i of n) typeof i == "string" ? o.push(this.traverseContentResource({ "@id": i, "@type": "dctypes:Image" })) : o.push(this.traverseContentResource(i));
    return !r && !this.options.convertPropsToArray ? o[0] : o;
  }
  traverseDescriptive(t) {
    return t.thumbnail && (t.thumbnail = this.traverseImageResource(t.thumbnail)), t.logo && (t.logo = this.traverseImageResource(t.logo)), t;
  }
  traverseOneOrMoreServices(t) {
    let r = Array.isArray(t), n = Array.isArray(t) ? t : [t], o = [];
    for (let i of n) o.push(this.traverseService(i));
    return !r && !this.options.convertPropsToArray ? o[0] : o;
  }
  traverseLinking(t) {
    return t.related && (t.related = this.traverseOneOrManyType(t.related, this.traversals.contentResource)), t.rendering && (t.rendering = this.traverseOneOrManyType(t.rendering, this.traversals.contentResource)), t.service && (t.service = this.traverseOneOrMoreServices(t.service)), t.seeAlso && (t.seeAlso = this.traverseOneOrManyType(t.seeAlso, this.traversals.contentResource)), t.within && (typeof t.within == "string" || (t.within = this.traverseOneOrManyType(t.within, this.traversals.contentResource))), t.startCanvas && (typeof t.startCanvas == "string" ? t.startCanvas = this.traverseType({ "@id": t.startCanvas, "@type": "sc:Canvas" }, this.traversals.canvas) : t.startCanvas && this.traverseType(t.startCanvas, this.traversals.canvas)), t.contentLayer && (typeof t.contentLayer == "string" ? t.contentLayer = this.traverseLayer({ "@id": t.contentLayer, "@type": "sc:Layer" }) : t.contentLayer = this.traverseLayer(t.contentLayer)), t;
  }
  traverseOneOrManyType(t, r) {
    if (!Array.isArray(t)) if (this.options.convertPropsToArray) t = [t];
    else return this.traverseType(t, r);
    return t.map((n) => this.traverseType(n, r));
  }
  traverseType(t, r) {
    return r.reduce((n, o) => {
      let i = o(n);
      return typeof i > "u" && !this.options.allowUndefinedReturn ? n : i;
    }, t);
  }
}, dn = "http://library.stanford.edu/iiif/image-api/compliance.html#level1", hn = "http://library.stanford.edu/iiif/image-api/compliance.html#level2", mn = "http://library.stanford.edu/iiif/image-api/conformance.html#level1", vn = "http://library.stanford.edu/iiif/image-api/conformance.html#level2", gn = "http://library.stanford.edu/iiif/image-api/1.1/compliance.html#level1", yn = "http://library.stanford.edu/iiif/image-api/1.1/compliance.html#level2", bn = "http://library.stanford.edu/iiif/image-api/1.1/conformance.html#level1", xn = "http://library.stanford.edu/iiif/image-api/1.1/conformance.html#level2", wn = "http://iiif.io/api/image/1/level1.json", Sn = "http://iiif.io/api/image/1/profiles/level1.json", Cn = "http://iiif.io/api/image/1/level2.json", En = "http://iiif.io/api/image/1/profiles/level2.json", An = "http://iiif.io/api/image/2/level1.json", $n = "http://iiif.io/api/image/2/profiles/level1.json", Rn = "http://iiif.io/api/image/2/level2.json", In = "http://iiif.io/api/image/2/profiles/level2.json", Ln = "level1", On = "level2", Tn = "http://iiif.io/api/image/2/level1", jn = "http://iiif.io/api/image/2/level2", Pn = [Tn, jn, dn, hn, mn, vn, gn, yn, bn, xn, wn, Sn, Cn, En, An, $n, Rn, In, Ln, On], te = { attributionLabel: "Attribution", lang: "none", providerId: "http://example.org/provider", providerName: "Unknown" };
function Mn(e) {
  if (typeof e == "string") return [e];
  if (!e) return [];
  let t = Array.isArray(e) ? e : [e], r = [];
  for (let n of t) {
    if (typeof n == "string") {
      r.push(n);
      continue;
    }
    r.push({ "@language": n["@language"] || n.language, "@value": n["@value"] || n.value });
  }
  return r;
}
function F(e, t = "none") {
  if (!e) return {};
  let r = Mn(e), n = {};
  for (let o of r) {
    if (typeof o == "string") {
      n[t] = n[t] ? n[t] : [], n[t].push(o || "");
      continue;
    }
    if (!o["@language"]) {
      n[t] = n[t] ? n[t] : [], n[t].push(o["@value"] || "");
      continue;
    }
    let i = o["@language"];
    n[i] = n[i] ? n[i] : [], n[i].push(o["@value"] || "");
  }
  return n;
}
function He(e) {
  if (Array.isArray(e)) return He(e.find((t) => typeof t == "string"));
  if (on.indexOf(e) !== -1) return "level2";
  if (Pn.indexOf(e) !== -1) return "level1";
  if (sn.indexOf(e) !== -1) return "level0";
  if (typeof e == "string") return e;
}
function _n(e) {
  let t = Array.isArray(e) ? e : [e];
  for (let r of t) switch (r) {
    case "http://iiif.io/api/image/2/context.json":
    case "http://library.stanford.edu/iiif/image-api/1.1/compliance.html#level2":
      return "ImageService2";
    case "http://iiif.io/api/image/1/context.json":
    case "http://library.stanford.edu/iiif/image-api/1.1/context.json":
      return "ImageService1";
    case "http://iiif.io/api/annex/openannotation/context.json":
      return "ImageApiSelector";
  }
}
function Nn(e) {
  switch (e) {
    case "http://iiif.io/api/image/2/level0.json":
    case "http://iiif.io/api/image/2/level1.json":
    case "http://iiif.io/api/image/2/level2.json":
      return "ImageService2";
    case "http://iiif.io/api/auth/1/kiosk":
    case "http://iiif.io/api/auth/1/login":
    case "http://iiif.io/api/auth/1/clickthrough":
    case "http://iiif.io/api/auth/1/external":
    case "http://iiif.io/api/auth/0/kiosk":
    case "http://iiif.io/api/auth/0/login":
    case "http://iiif.io/api/auth/0/clickthrough":
    case "http://iiif.io/api/auth/0/external":
      return "AuthCookieService1";
    case "http://iiif.io/api/auth/1/token":
    case "http://iiif.io/api/auth/0/token":
      return "AuthTokenService1";
    case "http://iiif.io/api/auth/1/logout":
    case "http://iiif.io/api/auth/0/logout":
      return "AuthLogoutService1";
    case "http://iiif.io/api/search/1/search":
    case "http://iiif.io/api/search/0/search":
      return "SearchService1";
    case "http://iiif.io/api/search/1/autocomplete":
    case "http://iiif.io/api/search/0/autocomplete":
      return "AutoCompleteService1";
  }
}
function he(e) {
  for (let t of ["sc", "oa", "dcterms", "dctypes", "iiif"]) if (e.startsWith(`${t}:`)) return e.slice(t.length + 1);
  return e;
}
var Dn = ["Collection", "Manifest", "Annotation", "AnnotationPage", "Range", "Service"];
function oe(e) {
  let t = e["@id"] || e.id, r = e["@type"] || e.type, n = e.profile || void 0, o = e["@context"] || void 0;
  if (n) {
    let i = Nn(n);
    if (i) return i;
  }
  if (o) {
    let i = _n(o);
    if (i) return i;
  }
  if (r) {
    if (Array.isArray(r)) {
      if (r.indexOf("oa:CssStylesheet") !== -1) return "CssStylesheet";
      if (r.indexOf("cnt:ContentAsText") !== -1) return "TextualBody";
      r = r[0];
    }
    for (let i of ["sc", "oa", "dcterms", "dctypes", "iiif"]) if (r.startsWith(`${i}:`)) {
      r = r.slice(i.length + 1);
      break;
    }
    switch (r) {
      case "Layer":
        return "AnnotationCollection";
      case "AnnotationList":
        return "AnnotationPage";
      case "cnt:ContentAsText":
        return "TextualBody";
    }
  }
  if (r && Dn.indexOf(r) !== -1) return r;
  if (e.format) {
    if (e.format.startsWith("image/")) return "Image";
    if (e.format.startsWith("text/") || e.format === "application/pdf") return "Text";
    if (e.format.startsWith("application/")) return "Dataset";
  }
  return t && (t.endsWith(".jpg") || t.endsWith(".png") || t.endsWith(".jpeg")) ? "Image" : r || "unknown";
}
var zn = /http(s)?:\/\/(creativecommons.org|rightsstatements.org)[^"'\\<\n]+/gm;
function Fn(e) {
  let t = e.match(zn);
  return t ? t[0] : e;
}
function kn(e, t = "Rights/License", r = "none") {
  let n = null, o = [], i = Array.isArray(e) ? e : [e];
  for (let l of i) {
    let p = l ? Fn(l) : void 0;
    if (p && (p.indexOf("creativecommons.org") !== -1 || p.indexOf("rightsstatements.org") !== -1)) {
      p.startsWith("https://") ? n = `http://${p.slice(8)}` : n = p;
      continue;
    }
    p && o.push({ label: { [r]: [t] }, value: { [r]: [p] } });
  }
  return [n, o];
}
var Vn = ["http://iiif.io/api/presentation/2/context.json", "http://iiif.io/api/image/2/context.json", "http://iiif.io/api/image/1/context.json", "http://library.stanford.edu/iiif/image-api/1.1/context.json", "http://iiif.io/api/search/1/context.json", "http://iiif.io/api/search/0/context.json", "http://iiif.io/api/auth/1/context.json", "http://iiif.io/api/auth/0/context.json", "http://iiif.io/api/annex/openannotation/context.json"];
function Bn(e) {
  if (e) {
    let t = Array.isArray(e) ? e : [e], r = [];
    for (let n of t) n === "http://iiif.io/api/presentation/2/context.json" && r.push("http://iiif.io/api/presentation/3/context.json"), Vn.indexOf(n) === -1 && r.push(n);
    if (t.length) return r.length === 1 ? r[0] : r;
  }
}
function Hn(e) {
  return e ? e.map((t) => ({ label: F(t.label), value: F(t.value) })) : [];
}
var me = 0;
function We(e, t) {
  let r = encodeURI(e.id || e["@id"] || "").trim();
  return r && t ? `${r}/${t}` : r || (me++, `http://example.org/${e["@type"]}${t ? `/${t}` : ""}/${me}`);
}
function R(e) {
  let t = [...e.behavior || []];
  e.viewingHint && t.push(e.viewingHint);
  let r;
  return Array.isArray(e.motivation) ? r = e.motivation.map(he) : e.motivation && (r = he(e.motivation)), { "@context": e["@context"] ? Bn(e["@context"]) : void 0, id: (e["@id"] || We(e)).trim(), type: oe(e), behavior: t.length ? t : void 0, height: e.height ? e.height : void 0, width: e.width ? e.width : void 0, motivation: r, viewingDirection: e.viewingDirection, profile: e.profile, format: e.format ? e.format : void 0, duration: void 0, timeMode: void 0 };
}
function I(e) {
  let [t, r] = kn(e.license), n = [...e.metadata ? Hn(e.metadata) : [], ...r];
  return { rights: t, metadata: n.length ? n : void 0, label: e.label ? F(e.label) : void 0, requiredStatement: e.attribution ? { label: F(te.attributionLabel), value: F(e.attribution) } : void 0, navDate: e.navDate, summary: e.description ? F(e.description) : void 0, thumbnail: Wn(e.thumbnail) };
}
function Wn(e) {
  return e && (Array.isArray(e) ? e : [e]).map((t) => typeof t == "string" ? { id: t, type: "Image" } : (t.type === "unknown" && (t.type = "Image"), t));
}
function qn(e) {
  if (!e.within) return;
  let t = Array.isArray(e.within) ? e.within : [e.within], r = [];
  for (let n of t) if (typeof n == "string") {
    if (n) switch (e["@type"]) {
      case "sc:Manifest":
        r.push({ id: n, type: "Collection" });
        break;
    }
  } else n["@id"] && r.push({ id: n["@id"], type: oe(n) });
  return r.length ? r : void 0;
}
function P(e) {
  let t = e.related ? Array.isArray(e.related) ? e.related : [e.related] : [], r = e.contentLayer;
  return { provider: e.logo || t.length ? [{ id: te.providerId, type: "Agent", homepage: t.length ? [t[0]] : void 0, logo: e.logo ? Array.isArray(e.logo) ? e.logo : [e.logo] : void 0, label: F(te.providerName) }] : void 0, partOf: qn(e), rendering: e.rendering, seeAlso: e.seeAlso, start: e.startCanvas, service: e.service ? ln(e.service) : void 0, supplementary: r ? [r] : void 0 };
}
function Un(e) {
  return { chars: e.chars, format: e.format ? e.format : void 0, language: e.language };
}
function Gn(e) {
  return E({ ...R(e), ...I(e), ...P(e), items: e.members });
}
function Jn(e) {
  let t = [], r = [], n;
  for (let i of e.sequences || []) i.canvases.length && t.push(...i.canvases), i.behavior && r.push(...i.behavior), i.startCanvas && (n = i.startCanvas);
  let o = R(e);
  return r.length && (o.behavior ? o.behavior.push(...r) : o.behavior = r), E({ ...o, ...I(e), ...P(e), start: n, items: t, structures: Kn(e.structures) });
}
function Kn(e) {
  if (!e) return e;
  let t = /* @__PURE__ */ new Map();
  for (let n of e) t.set(n.id, n);
  let r = [];
  for (let n of e) if (n.items) {
    let o = n.items.map((i) => typeof i == "string" ? (r.push(i), t.get(i) || i) : i && i.id ? (r.push(i.id), t.get(i.id) || i) : i);
    n.items = o;
  }
  return e.filter((n) => r.indexOf(n.id) === -1);
}
function Zn(e) {
  return E({ ...R(e), ...I(e), ...P(e), annotations: e.otherContent && e.otherContent.length ? e.otherContent : void 0, items: e.images && e.images.length ? [{ id: We(e, "annotation-page"), type: "AnnotationPage", items: e.images }] : void 0 });
}
function Qn(e) {
  return E({ ...R(e), ...I(e), ...P(e), items: e.resources && e.resources.length ? e.resources : void 0 });
}
function Xn(e) {
  return !e.canvases || e.canvases.length === 0 ? { canvases: [], behavior: [] } : { canvases: e.canvases, behavior: e.viewingHint ? [e.viewingHint] : [], startCanvas: e.startCanvas };
}
function Yn(e) {
  function t(r) {
    if (Array.isArray(r)) {
      if (r.length > 1) return { type: "List", items: r.map(t) };
      r = r[0];
    }
    if (typeof r == "string") return encodeURI(r).trim();
    if ("@type" in r) {
      let n;
      if (typeof r.full == "string") n = r.full;
      else if (r.full["@type"] === "dctypes:Image") n = { id: r.full["@id"], type: "Image" };
      else if (r.full["@type"] === "sc:Canvas") n = { id: r.full["@id"], type: "Canvas" };
      else throw new Error(`Unsupported source type on annotation: ${r.full["@type"]}`);
      return { type: "SpecificResource", source: n, selector: re(r.selector) };
    } else return encodeURI(r["@id"]).trim();
  }
  return E({ ...R(e), ...I(e), ...P(e), target: t(e.on), body: Array.isArray(e.resource) ? e.resource.map(ve) : ve(e.resource) });
}
function ve(e) {
  return e.type === "Choice" ? e : qe(e);
}
function qe(e) {
  let t = e;
  return E({ ...R(t), ...I(t), ...P(t), ...Un(t) });
}
function ei(e) {
  let t = [];
  return e.default && e.default !== "rdf:nil" && t.push(e.default), e.item && e.item !== "rdf:nil" && t.push(...e.item), E({ ...R(e), ...I(e), items: t });
}
function ti(e) {
  return E({ ...R(e), ...I(e), ...P(e), items: e.members });
}
function ri(e) {
  let { "@id": t, "@type": r, "@context": n, profile: o, ...i } = e, l = {};
  return t && (l["@id"] = t), l["@type"] = oe(e), l["@type"] === "unknown" && (n && n.length && (l["@context"] = n), l["@type"] = "Service"), o && (l.profile = He(o)), E({ ...l, ...i });
}
function ni(e) {
  return E({ ...R(e), ...I(e), ...P(e) });
}
var ii = new fn({ collection: [Gn], manifest: [Jn], canvas: [Zn], annotationList: [Qn], sequence: [Xn], annotation: [Yn], contentResource: [qe], choice: [ei], range: [ti], service: [ri], layer: [ni] });
function oi(e) {
  return e && e["@context"] && (e["@context"] === "http://iiif.io/api/presentation/2/context.json" || e["@context"].indexOf("http://iiif.io/api/presentation/2/context.json") !== -1 || e["@context"] === "http://www.shared-canvas.org/ns/context.json") || e["@context"] === "http://iiif.io/api/image/2/context.json" ? ii.traverseUnknown(e) : e;
}
function re(e) {
  if ((Array.isArray(e["@type"]) && e["@type"].includes("oa:SvgSelector") || e["@type"] == "oa:SvgSelector") && ("chars" in e || "value" in e)) return { type: "SvgSelector", value: "chars" in e ? e.chars : e.value };
  if (e["@type"] === "oa:FragmentSelector") return { type: "FragmentSelector", value: e.value };
  if (e["@type"] === "oa:Choice") return [re(e.default), ...(Array.isArray(e.item) ? e.item : [e.item]).map(re)];
  if (e["@type"] == "iiif:ImageApiSelector") return { type: "ImageApiSelector", region: "region" in e ? e.region : void 0, rotation: "rotation" in e ? e.rotation : void 0 };
  throw new Error(`Unsupported selector type: ${e["@type"]}`);
}
var ai = oi;
const xi = (e) => /* @__PURE__ */ a.createElement(
  Nt,
  {
    initialState: {
      ...G,
      options: { ...e.options }
    }
  },
  /* @__PURE__ */ a.createElement(si, { ...e })
), si = ({
  collectionId: e,
  iiifContent: t,
  onItemInteraction: r
}) => {
  const n = Dt(), { options: o } = n, [i, l] = $();
  let p = t;
  if (e && (p = e), j(() => {
    p && fetch(p).then((d) => d.json()).then(ai).then((d) => l(d)).catch((d) => {
      console.error(
        `The IIIF Collection ${p} failed to load: ${d}`
      );
    });
  }, [p]), (i == null ? void 0 : i.items.length) === 0)
    return console.log(`The IIIF Collection ${p} does not contain items.`), /* @__PURE__ */ a.createElement(a.Fragment, null);
  const s = o.customViewAll ? [
    {
      id: o.customViewAll,
      type: "Text",
      format: "text/html"
    }
  ] : i == null ? void 0 : i.homepage, c = Dr(p);
  return i ? /* @__PURE__ */ a.createElement("div", null, /* @__PURE__ */ a.createElement(rt, { FallbackComponent: Ht }, /* @__PURE__ */ a.createElement(
    pr,
    {
      label: i.label,
      summary: i && i.summary ? i.summary : { none: [""] },
      homepage: s,
      instance: c
    }
  ), /* @__PURE__ */ a.createElement(
    Nr,
    {
      items: i.items,
      handleItemInteraction: r,
      instance: c,
      breakpoints: o.breakpoints
    }
  ))) : /* @__PURE__ */ a.createElement(a.Fragment, null);
};
export {
  xi as default
};
//# sourceMappingURL=index.mjs.map
